function jacobian_indexAll = makeJacobianIndex

jacobian_indexAll = cell(1,1);


x = ones(34,1);


%% Drugs
fluxMDZ = createSmallflux(x(11:20),x(1));
fluxTPV = createSmallflux(x(21:30),x(1));

%% Combine flux
z = zeros(10,10);

flux = [...
    fluxMDZ,z,z,z,z;...
    z,fluxMDZ,z,z,z;...
    z,z,fluxMDZ,z,z;...
    z,z,z,fluxMDZ,z;...
    z,z,z,z,fluxTPV;...
    ];

flux = [flux,zeros(50,5); zeros(5,50),eye(5)];


%% Combine and Put -(sum(outflow)) at flux(k,k) to keep mass balance

fluxDiag=sum(flux - diag(diag(flux)),1);
flux = flux - diag(fluxDiag);




jacobian_index = flux ./ flux;
jacobian_index(isnan(jacobian_index)) = 0;

jacobian_indexAll{1} = sparse(jacobian_index);

end




function flux = createSmallflux(x,qh)

flux = zeros(10);

%% Rapid and peripheral
flux(3,1) = qh;            % rapid to Liver 1
flux(1,1) =-x(7);          % Rapid to Urine

flux(2,1) = x(5);          % rapid to peripheral
flux(1,2) = x(6);          % peripheral to rapid

%% Intestine
flux(3,8) = x(2)*x(3);     % intestine to HE1
flux(8,8) =-x(2)*(1-x(3)); % intestine to feces

%% Metabolism
fBCLint_5_Kp  = x(8) * x(9) / x(4) * 0.2;
flux(3:7,3:7) = flux(3:7,3:7) - fBCLint_5_Kp * eye(5); 

%% Hepatic Blood
flux(4,3) = qh/x(4);
flux(5,4) = qh/x(4);
flux(6,5) = qh/x(4); 
flux(7,6) = qh/x(4);
flux(1,7) = qh/x(4); % Liver 5 to rapid

end
