function jacobian_indexAll = makeJacobianIndex

jacobian_indexAll = cell(1,1);

% Construct small flux matrix
flux1  = eye(5); % rapid to late
flux2  = eye(5); % late to rapid 
flux3  = eye(5); % rapid to liver 
flux4  = eye(5); % rapid to liver 
flux5  = eye(5); % rapid to urine 
flux6  = eye(5); % liver to transit 1 
flux7  = eye(5); % liver to bile 
flux8  = eye(5); % intestine to liver
flux9  = eye(5); % intestine to large intestine
flux11 = eye(5); % transit 1 to 2, 2 to 3, 3 to intestine
flux12 = eye(5); % large intestine to feces


% Metabolism
flux10 = zeros(5);
flux10(2,1) = 1; % CPT11 to APC  , 3A4_1
flux10(4,1) = 1; % CPT11 to NPC  , 3A4_2
flux10(5,1) = 1; % CPT11 to SN38 , CES_1 
flux10(3,2) = 1; % NPC   to SN38 , CES_2
flux10(2,4) = 1; % SN38  to SN38G, UGT 

% Construct full flux matrix
flux = zeros(50);
flux(6:10,  1:5  ) = flux1;
flux(1:5,   6:10 ) = flux2;
flux(11:15, 1:5  ) = flux3;
flux(1:5,   11:15) = flux4;
flux(21:25, 1:5  ) = flux5;
flux(36:40, 11:15) = flux6;
flux(31:35, 11:15) = flux7;
flux(11:15, 16:20) = flux8;
%flux(26:30, 16:20) = flux9;
flux(51:55, 16:20) = flux9;
flux(11:15, 11:15) = flux10;
flux(41:45, 36:40) = flux11;
flux(46:50, 41:45) = flux11;
flux(16:20, 46:50) = flux11;
flux(26:30, 51:55) = flux12;

% Put -(sum(outflow)) at flux(k,k) to keep mass balance
fluxDiag=sum(flux - diag(diag(flux)),1);
flux = flux - diag(fluxDiag);

jacobian_index = flux ./ flux;
jacobian_index(isnan(jacobian_index)) = 0;

jacobian_indexAll{1} = sparse(jacobian_index);

end

