function jacobian_indexAll = makeJacobianIndex

jacobian_indexAll = cell(1,1);

x = ones(41,1);

%% Prepare flux for substrate
flux = zeros(20);

flux(2,1)  = x(1);   % rapid to HE1
flux(1,1)  =-x(17);  % rapid to urine

flux(17,1) = x(18);  % rapid to distribution
flux(1,17) = x(19);  % distribution to rapid

flux(12,13) = x(13); % Intestinal transit to intestine
flux(2,12)  = x(12); % intestine to HE1
flux(12,12) =-x(21); % intestine to feces

flux(15,14) = x(20); % transit 1 to 2
flux(16,15) = x(20); % transit 2 to 3
flux(12,16) = x(20); % transit 3 to intestine

fBPSinf  = x(14) * 0.2;
fHPSeff  = x(15) * 0.2;
fHCLint  = x(16) * 0.2;
fHCLbile = fHCLint      /(1+x(22));
fHCLmet  = fHCLint*x(22)/(1+x(22));
fluxHEHC = [0, fHPSeff; fBPSinf, -fHCLmet];

flux(2:3,  2 :3 ) = fluxHEHC; 
flux(4:5,  4 :5 ) = fluxHEHC; 
flux(6:7,  6 :7 ) = fluxHEHC; 
flux(8:9,  8 :9 ) = fluxHEHC; 
flux(10:11,10:11) = fluxHEHC; 
flux(4 ,2 ) = x(1);
flux(6 ,4 ) = x(1);
flux(8 ,6 ) = x(1); 
flux(10,8 ) = x(1);
flux(1,10 ) = x(1); % HE5 to rapid
flux(14,[3,5,7,9,11]) = fHCLbile; 


fluxCont = flux;
fluxDDI  = flux;


%% Prepare flux for Inhibitor

flux = zeros(20);

flux(2,1)  = x(1);   % rapid to HE1
flux(1,1)  =-x(37);  % rapid to urine

flux(17,1) = x(38);  % rapid to distribution
flux(1,17) = x(39);  % distribution to rapid

flux(12,13) = x(33); % Intestinal transit to intestine
flux(2,12)  = x(32); % intestine to HE1

fBPSinf  = x(34) * 0.2;
fHPSeff  = x(35) * 0.2;
fHCLint  = x(36) * 0.2;
fluxHEHC = [0, fHPSeff; fBPSinf, -fHCLint];

flux(2:3,  2 :3 ) = fluxHEHC; 
flux(4:5,  4 :5 ) = fluxHEHC; 
flux(6:7,  6 :7 ) = fluxHEHC; 
flux(8:9,  8 :9 ) = fluxHEHC; 
flux(10:11,10:11) = fluxHEHC; 
flux(4 ,2 ) = x(1);
flux(6 ,4 ) = x(1);
flux(8 ,6 ) = x(1); 
flux(10,8 ) = x(1);
flux(1,10 ) = x(1); % HE5 to rapid

fluxInhi = flux;


%% Combine flux
z = zeros(20,20);

flux = [fluxCont,z,z; z,fluxDDI,z; z,z,fluxInhi];


% Put -(sum(outflow)) at flux(k,k) to keep mass balance
fluxDiag=sum(flux - diag(diag(flux)),1);
flux = flux - diag(fluxDiag);

jacobian_index = flux ./ flux;
jacobian_index(isnan(jacobian_index)) = 0;

jacobian_indexAll{1} = sparse(jacobian_index);

end

