function parDistCmp_Xiter(X,ylimRange,Xinit,dispIter,fignum)
%
% parDistCmp_Xiter(X,[-5,5])
% parDistCmp_Xiter(X,[-1.5,1.5])


if nargin == 1,ylimRange = []; end
if nargin <  3
    for k = 1:size(X,3)
        XinitRep(:,:,k) = X(:,:,1); %#ok<AGROW>
    end
    Xinit = XinitRep;
end
if nargin < 4
    dispIter = [1,2,3,4,10];
end
if nargin < 5
    fignum = 1;
end

%parDistCmp(IniX, FinX, isLog10, isNormalize, isAddOrig, ylimRange)
kiter = 0;

figure(6)
for k = dispIter;
    kiter = kiter+1;
    subplot(numel(dispIter),1,kiter)
    parDistCmp(exp(Xinit(:,:,k)), exp(X(:,:,k)), 1, 1, 0, ylimRange);
    set(gca,'FontSize',16);
    %    hgexport(figure(6), ['x',num2str(k),'.eps'])
    %    saveas(  figure(6), ['x',num2str(k),'.fig'])
end

set(gcf,'Position',[-500,0,400,900]);
%hgexport(figure(6), ['../temp/x',num2str(fignum),'.eps'])
saveas(figure(6), ['../temp/x',num2str(fignum),'.fig'])



    function parDistCmp(initXfree, finalXfree, ...
            isLog10, isNormalize, isAddOrig, ylimRange)
        
        %% Initialize
        
        if nargin == 2,isLog10    = 0; end
        if nargin <= 3,isNormalize= 0; end
        if nargin <= 4,isAddOrig  = 0; end
        
        if nargin <= 5,             autoYlim = 1;
        elseif numel(ylimRange)==0, autoYlim = 1;
        else autoYlim = 0;
        end
        
        list = listfonts;
        if sum(strcmp(list,'Myriad Pro'))
            fontUse = 'Myriad Pro';
        else
            'Use Myriad Pro' %#ok<NOPRT>
            fontUse = get(0,'defaultAxesFontName');
        end
        
        if isLog10
            initXfree  = log10(initXfree)';
            finalXfree = log10(finalXfree)';
            isLog10Str = 'log10';
        else
            initXfree  = initXfree';
            finalXfree = finalXfree';
            isLog10Str = '';
        end
        
        initSampNum = size(finalXfree,1); %#ok<NASGU>
        finalSampNum = size(finalXfree,1); %#ok<NASGU>
        freeNum = size(initXfree,2);
        if freeNum ~= size(finalXfree,2)
            error('Numbers of free parameters do not match')
        end
        
        
        %% Settings
        
        axLabelFontSize= 16;
        axFontSize     = 10;
        titleFontSize  = 20;
        yellowNumInit  = 0;
        yellowNumFinal = 0;
        
        
        %% Normalize values
        
        if isNormalize == 1;
            [initXfree,finalXfree]=normalizeFinalX(initXfree,finalXfree);
            ylabelStr = ['normalized ' isLog10Str ' parameter values'];
        else
            ylabelStr = [isLog10Str ' parameter values'];
        end
        
        
        %% Original distribution
        %figure(6);
        set(gcf, 'Renderer', 'zbuffer')
        
        switch isAddOrig
            case {1,2}
                
                subplot(isAddOrig,3-isAddOrig,2);
                
                initXplot=initXfree(yellowNumInit+1:end,:);
                plot(1:freeNum,initXplot,'Color',[0,0,1],'linewidth',1)
                hold on
                if yellowNumFinal>0
                    initXplot=initXfree(1:yellowNumInit,:);
                    plot(1:freeNum,initXplot,'Color',[1,1,0],'linewidth',1)
                end
                
                set(gca,'FontSize',axFontSize);
                xlabel('#parameters ','FontSize',axLabelFontSize)
                title('Original','FontSize',titleFontSize)
                
                xlim([0.5 freeNum+0.5])
                if autoYlim==1
                    ylimRange1 = ylim;
                end
        end
        
        %% Fitted distribution
        
        switch isAddOrig
            case {0,1,2}
                
                if isAddOrig ~= 0, subplot(isAddOrig,3-isAddOrig,2), end;
                
                finalXplot=finalXfree(yellowNumFinal+1:end,:);
                h = plot(1:freeNum,finalXplot,'Color',[0,0,1],'linewidth',1); % Blue
                hold on
                if yellowNumFinal>0
                    finalXplot=finalXfree(1:yellowNumFinal,:);
                    h = plot(1:freeNum,finalXplot,'Color',[1,1,0],'linewidth',1); % Yellow
                end
                
                
            case 3
                
                initXrange = [min(initXfree);max(initXfree)]';
                finalXrange= [min(finalXfree);max(finalXfree)]';
                h = plotCombXrange(initXrange,finalXrange,freeNum,128);
                
                
        end
        
        hold off
        set(gca,'FontSize',axFontSize,'FontName',fontUse);
        
        %{
        if kiter == 2
            ylabel(ylabelStr,'FontSize',axLabelFontSize)
        end
        %xlabel('#parameters ','FontSize',axLabelFontSize)
        %title('Optimized','FontSize',titleFontSize)
        %}
        
        
        %% Set axis properties
        
        if autoYlim==1
            switch isAddOrig
                case {0,3}
                    ylimRange = ylim;
                case {1,2}
                    ylimRange2 = ylim;
                    ylimRange = ...
                        [min(ylimRange1(1),ylimRange2(1)) max(ylimRange1(2),ylimRange2(2))];
            end
        end
        setAxis(freeNum,isAddOrig,ylimRange,isNormalize,h)
        
        
    end




    function [initXfree,finalXfree]=normalizeFinalX(initXfree,finalXfree)
        
        initXfreeMean  = (max(initXfree) + min(initXfree))/2;
        initXfreeRange =  max(initXfree) - min(initXfree);
        initXfreeRange = diag(1./initXfreeRange);
        initXfree = ...
            (initXfree - repmat(initXfreeMean,size(initXfree,1),1))...
            *initXfreeRange*2;
        finalXfree = ...
            (finalXfree - repmat(initXfreeMean,size(finalXfree,1),1))...
            *initXfreeRange*2;
        
    end





    function h = plotCombXrange(initXrange,finalXrange,freeNum,xdiv)
        
        
        
        TEST = 0;
        if TEST
            xdiv = 128; %#ok<UNRCH>
            freeNum = 5;
            initXrange  = [[-1 -2 -1  -1 -2]' [ 2 -1  0    0  0]' ];
            finalXrange = [[ 3 -4 -3  -2 -2]' [ 4 -3 -1.5 -1 -1]' ];
            
        end
        
        
        dx = 1/xdiv;
        
        initXmin  = initXrange(:,1);
        initXmax  = initXrange(:,2);
        finalXmin = finalXrange(:,1);
        finalXmax = finalXrange(:,2);
        xrangeTmp = [initXmin,initXmax,finalXmin,finalXmax];
        
        xrange        = zeros((freeNum-1)*xdiv+1,6);
        xVec = xrangeTmp(1,:);
        xrange(1,1:4) = xVec;
        xrange(1,5:6) = [max(xVec([1,3])), min(xVec([2,3]))];
        
        for k1 = 1:freeNum-1
            for k2 = 1:xdiv
                xVec = ...
                    (xrangeTmp(k1,:)*(xdiv-k2) + xrangeTmp(k1+1,:)*k2)/xdiv;
                
                
                if xVec(4) < xVec(1)
                    xVec(5) = xVec(4);
                else
                    xVec(5) = max(xVec(1),xVec(3));
                end
                
                
                if xVec(3) > xVec(2)
                    xVec(6) = xVec(3);
                else
                    xVec(6) = min(xVec(2),xVec(4));
                end
                
                xrange((k1-1)*xdiv+k2+1,:) = xVec;
                
            end
        end
        
        xrange = [xrange(:,1),xrange(:,2)-xrange(:,1),...
            xrange(:,3)-xrange(:,2),xrange(:,4)-xrange(:,3),...
            xrange(:,5)-xrange(:,4),xrange(:,6)-xrange(:,5)];
        
        h = area(1+0:dx:freeNum,xrange,'LineStyle','none');
        grid on
        set(h(1),'Visible','off')
        set(h(3),'Visible','off')
        set(h(5),'Visible','off')
        set(h(2),'FaceColor',[0 65 255]/255)
        set(h(4),'FaceColor',[53 161 107]/255)
        set(h(6),'FaceColor',[255 153 0]/255)
        %set(gca,'Layer','top')
        set(h,'LineStyle','none')
        
        
        
    end



    function setAxis(freeNum,isAddOrig,ylimRange,isNormalize,h)
        
        xlim([0.5 freeNum+0.5])
        switch isAddOrig
            case 0
                ylim(ylimRange); grid on;
                if isNormalize, addytick(1);addytick(-1); end
                set(gca,'xtick',unique([1:5:freeNum,freeNum]));
            case {1,2}
                
                subplot(isAddOrig,3-isAddOrig,2); ylim(ylimRange); grid on;
                if isNormalize, addytick(1);addytick(-1); end
                set(gca,'xtick',unique([1:5:freeNum,freeNum]));
                
                subplot(isAddOrig,3-isAddOrig,1); ylim(ylimRange); grid on;
                if isNormalize, addytick(1);addytick(-1); end
                set(gca,'xtick',unique([1:5:freeNum,freeNum]));
            case 3
                
                ylim(ylimRange); grid on;
                if isNormalize, addytick(1);addytick(-1); end
                set(gca,'xtick',unique([1:5:freeNum,freeNum]));
                
                set(h,'BaseValue',ylimRange(1));
        end
        
        
    end



    function addytick( tk, tklbl )
        %ADDXTICK --- Add new tick to x-axis
        %   Ex.    addxtick(3.14)
        %   Ex2.  addxtick(3.14, 'Pi')
        %
        % http://ichiro-maruta.blogspot.jp/2009/01/matlab.html
        
        if nargin==1
            set(gca,'YTick',unique(sort([get(gca,'YTick'), tk ] )));
        else
            temp = cellstr(get(gca,'YTickLabel'));
            % temp = {temp{:},tklbl};
            % If A is a cell array with a single row, replace { A{:} X } with [A {X}]
            temp = [temp {tklbl}];
            [temp2,idx] = sort([get(gca,'YTick'),tk]);
            [temp2,idx2]=unique(temp2);
            idx=idx(idx2);
            set(gca,'YTick',temp2);
            set(gca,'YTickLabel',temp(idx));
        end
        
    end


end







