function parDistCmp_Yiter(Y,Yinit,y_star,ylimRange,dispIter,fignum)
% parDistCmp_Yiter(Y,Y(:,:,1),y_star,[-6,2])

if nargin == 1,ylimRange = []; end
if size(Yinit,3)==1
    for k = 1:size(Y,3)
        YinitRep(:,:,k) = Yinit; %#ok<AGROW>
    end
    Yinit = YinitRep;
end
if nargin < 5
    dispIter = [1,2,3,4,10];
end
if nargin < 6
    fignum = 1;
end

%parDistCmp(IniX, FinX, isLog10, isNormalize, isAddOrig, ylimRange)
kiter = 0;
for k = 1:size(Y,3)
    Y_normInit(:,:,k) = ...
        diag(1./y_star)*Yinit(:,sum(Yinit(:,:,k),1)~=Inf,k); %#ok<AGROW>
end
%Y_normInit = Y_normInit + 1000;

figure(6)
for k = dispIter;
    kiter = kiter+1;
    subplot(numel(dispIter),1,kiter)
    parDistCmp(Y_normInit(:,:,k),Y(:,:,k),y_star, ylimRange);
    set(gca,'FontSize',16);
    %    hgexport(figure(6), ['x',num2str(k),'.eps'])
    %    saveas(  figure(6), ['x',num2str(k),'.fig'])
end

set(gcf,'Position',[-500,0,300,900]);
hgexport(figure(6), ['y',num2str(fignum),'.eps'])



    function parDistCmp(Y_normInit,Y,y_star, ylimRange)
        
        list = listfonts;
        if sum(strcmp(list,'Myriad Pro'))
            fontUse = 'Myriad Pro';
        else
            'Use Myriad Pro' %#ok<NOPRT>
            fontUse = get(0,'defaultAxesFontName');
        end
        
        if numel(ylimRange)==0, autoYlim = 1; else autoYlim = 0; end
        
        %% Calculate Y_normalized
        Y_norm=diag(1./y_star)*Y(:,sum(Y,1)~=Inf);
        
        initXfree = log10(Y_normInit);
        finalXfree = log10(Y_norm);
        
        finalSampNum = size(finalXfree,1); %#ok<NASGU>
        freeNum = size(finalXfree,1); 
        
        %% Fitted distribution
        
        initXrange = [min(initXfree);max(initXfree)]';
        finalXrange= [min(finalXfree);max(finalXfree)]';
        
        h = plotCombXrange(initXrange,finalXrange,freeNum,128);
        
        
        hold off
        set(gca,'FontSize',12,'FontName',fontUse);
        
        
        
        %% Set axis properties
        
        if autoYlim==1
            ylimRange = ylim;
        end
        setAxis(freeNum,3,ylimRange,0,h)
        
        
    end




    function h = plotCombXrange(initXrange,finalXrange,freeNum,xdiv)
        
        
        
        TEST = 0;
        if TEST
            xdiv = 128; %#ok<UNRCH>
            freeNum = 5;
            initXrange  = [[-1 -2 -1  -1 -2]' [ 2 -1  0    0  0]' ];
            finalXrange = [[ 3 -4 -3  -2 -2]' [ 4 -3 -1.5 -1 -1]' ];
            
        end
        
        
        dx = 1/xdiv;
        
        initXmin  = initXrange(:,1);
        initXmax  = initXrange(:,2);
        finalXmin = finalXrange(:,1);
        finalXmax = finalXrange(:,2);
        xrangeTmp = [initXmin,initXmax,finalXmin,finalXmax];
        
        xrange        = zeros((freeNum-1)*xdiv+1,6);
        xVec = xrangeTmp(1,:);
        xrange(1,1:4) = xVec;
        xrange(1,5:6) = [max(xVec([1,3])), min(xVec([2,3]))];
        
        for k1 = 1:freeNum-1
            for k2 = 1:xdiv
                xVec = ...
                    (xrangeTmp(k1,:)*(xdiv-k2) + xrangeTmp(k1+1,:)*k2)/xdiv;
                
                
                if xVec(4) < xVec(1)
                    xVec(5) = xVec(4);
                else
                    xVec(5) = max(xVec(1),xVec(3));
                end
                
                
                if xVec(3) > xVec(2)
                    xVec(6) = xVec(3);
                else
                    xVec(6) = min(xVec(2),xVec(4));
                end
                
                xrange((k1-1)*xdiv+k2+1,:) = xVec;
                
            end
        end
        
        xrange = [xrange(:,1),xrange(:,2)-xrange(:,1),...
            xrange(:,3)-xrange(:,2),xrange(:,4)-xrange(:,3),...
            xrange(:,5)-xrange(:,4),xrange(:,6)-xrange(:,5)];
        
        h = area(1+0:dx:freeNum,xrange,'LineStyle','none');
        grid on
        set(h(1),'Visible','off')
        set(h(3),'Visible','off')
        set(h(5),'Visible','off')
        set(h(2),'FaceColor',[0 65 255]/255)
        set(h(4),'FaceColor',[53 161 107]/255)
        set(h(6),'FaceColor',[255 153 0]/255)
        %set(gca,'Layer','top')
        set(h,'LineStyle','none')
        
        
        
    end



    function setAxis(freeNum,isAddOrig,ylimRange,isNormalize,h)
        
        xlim([0.5 freeNum+0.5])
        switch isAddOrig
            case 3
                
                ylim(ylimRange); grid on;
                if isNormalize, addytick(1);addytick(-1); end
                set(gca,'xtick',1:freeNum);
                
                set(h,'BaseValue',ylimRange(1));
        end
        
        
    end



    function addytick( tk, tklbl )
        %ADDXTICK --- Add new tick to x-axis
        %   Ex.    addxtick(3.14)
        %   Ex2.  addxtick(3.14, 'Pi')
        %
        % http://ichiro-maruta.blogspot.jp/2009/01/matlab.html
        
        if nargin==1
            set(gca,'YTick',unique(sort([get(gca,'YTick'), tk ] )));
        else
            temp = cellstr(get(gca,'YTickLabel'));
            % temp = {temp{:},tklbl};
            % If A is a cell array with a single row, replace { A{:} X } with [A {X}]
            temp = [temp {tklbl}];
            [temp2,idx] = sort([get(gca,'YTick'),tk]);
            [temp2,idx2]=unique(temp2);
            idx=idx(idx2);
            set(gca,'YTick',temp2);
            set(gca,'YTickLabel',temp(idx));
        end
        
    end


end







