function saveFm(FinalX,resultFolder,calcTypeList,calcFmType)

figure(15)

indCYP = 1:4;
indMet = 1:4;

if nargin < 4
    calcFmType = 1;
end

switch nargin
    case 1
        resultFolder = './';
        exportFile1 = [resultFolder,'fig/fm'];
        exportFile2 = [resultFolder,'fig/fm_eachMet'];
    case {3,4}
        exportFile1 = [resultFolder,'../../fm_',calcTypeList];
        exportFile2 = [resultFolder,'../../fm_eachMet',calcTypeList];
        
        csvwrite([resultFolder,'../../ki_',calcTypeList,'.csv'],...
            FinalX(:,96:110))
    otherwise
        error('Wrong nargin')
end

fold_o = [resultFolder,'fig/'];
mkdir(fold_o)

%fileNameArr = {'_cont','_inhi'};
subpCol = max(numel(indCYP),numel(indMet));

%% Calculate fm
xin = FinalX;
if calcFmType == 1
    [fm,fm_eachMet_o] = calculateFm(xin);
else
    [fm,fm_eachMet_o] = calculateFm_diffFmDef(xin);
end

muhatVec    =mean(fm);
sigmahatVec = std(fm);

%% Plot and Export

figure(15);

createPlot(fm,1,indCYP,indMet);
hgexport(figure(15),[exportFile1,'.png'],hgexport('factorystyle'),'Format','png')
csvwrite([exportFile1,'.csv'], fm)
csvwrite([exportFile2,'.csv'], fm_eachMet_o)




    function createPlot(fm,kFig,indCYP,indMet) %#ok<INUSL>
        subpPos = 1;
        for k1 = indCYP
            subplot(2,subpCol,subpPos);
            plot(fm(:,k1));
            ylim([0,1]);
            
            plotMeanSD(muhatVec(k1),sigmahatVec(k1))
            
            set(gca,'FontSize',15)
            grid on
            
            subpPos = subpPos + 1;
        end
        
        
        subpPos = 1;
        for k1 = indMet
            subplot(2,subpCol,subpPos+subpCol);
            plot(fm(:,k1+4));
            ylim([0,1]);
            
            plotMeanSD(muhatVec(k1+4),sigmahatVec(k1+4))
            
            set(gca,'FontSize',15)
            grid on
            
            subpPos = subpPos + 1;
        end
        
        
        set(figure(15),'position', [150 50 250*subpCol 450]);
    end


    function plotMeanSD(muhat,sigmahat)
        
        xlimCurr = xlim';
        musigma = [muhat+sigmahat,muhat-sigmahat];
        
        if muhat > 0
            hold on
            plot(xlimCurr,[muhat;muhat],    'm-', 'LineWidth',1)
            plot(xlimCurr,[musigma;musigma],'m--','LineWidth',1)
            hold off
        end
        
    end

end
