function parahist(i,X,q)
%Plots the histogram distribution of the initial and final distribution for
%the parameter x_i.

close(figure(1))

[num_para,num_sample,~]=size(X);
switch q
    case 1
        %Create the initial distribution of parameter x_i
        hist(exp(X(i,:,1)),floor(sqrt(num_sample)))
        h = findobj(gca,'Type','patch');
        set(h,'FaceColor','g','EdgeColor','w','facealpha',0.75)
        hold on;
        
        %Create the final distribution of parameter x_i
        hist(exp(X(i,:,end)),floor(sqrt(num_sample)))
        h1 = findobj(gca,'Type','patch');
        set(h1,'facealpha',0.75);
        
        %plotting options
        legend('Initial Distribution','Final Distribution')
        strg = 'Parameter Distribution before and after CNM for parameter';
        title( [strg ' ' num2str(i)] );
        xlabel('Range');
        ylabel('Number of points in columns')
        
        
        hold off
        
    case 2
        %Create the initial distribution of parameter x_i
        hist(X(i,:,1),floor(sqrt(num_sample)))
        h = findobj(gca,'Type','patch');
        set(h,'FaceColor','g','EdgeColor','w','facealpha',0.75)
        hold on;
        
        %Create the final distribution of parameter x_i
        hist(X(i,:,end),floor(sqrt(num_sample)))
        h1 = findobj(gca,'Type','patch');
        set(h1,'facealpha',0.75);
        
        %plotting options
        legend('Initial Distribution in log scale','Final Distribution in log scale')
        strg = 'Parameter Distribution before and after CNM for parameter in log scale';
        title( [strg ' ' num2str(i)] );
        xlabel('Range');
        ylabel('Number of points in columns')
        
        
        hold off
end
end