function goalVector = PBPK_model_LM(xfree)

global Numbers2 ForODE2 ParameterIndex2 InitialXY2 Model2
Numbers = Numbers2;
ForODE = ForODE2;
ParameterIndex = ParameterIndex2;
Model = Model2;

freelimits = InitialXY2.freelimits;
pindExp = ParameterIndex.exp;
pindSin = ParameterIndex.sin;

xFitOrig = xfree;
xFitOrig(pindExp) = exp(xFitOrig(pindExp))+freelimits(1,pindExp);
%xFitOrig(pindSin) = (sin(xFitOrig(pindSin))+1)./2.*...
%    (freelimits(2,pindSin)-freelimits(1,pindSin))+...
%    freelimits(1,pindSin);

limPlus = freelimits(2,pindSin) + freelimits(1,pindSin);
limMinus= freelimits(2,pindSin) - freelimits(1,pindSin);
xFitOrig(pindSin) = (limPlus + limMinus .* sin(xFitOrig(pindSin)))/2;

x_in(ParameterIndex.fix) = InitialXY2.xfix;
x_in(ParameterIndex.free) = xFitOrig;


%% Solve PBPK

uCalcAll = [];

for conditionNumber = 1:Numbers.sepCond
   
    [~,t,uCalc]=...
        PBPK_model(x_in, Model, Numbers, ForODE, 1, conditionNumber, 0);
    
    sizeuCalc = size(uCalc,1);
    if sizeuCalc<size(Numbers.timePoints,2)
        uCalc = [uCalc; ...
            zeros(size(Numbers.timePoints,2) - ...
            sizeuCalc, Numbers.compAll(conditionNumber))]; %#ok<AGROW>
    end
    
    uCalcAll = [uCalcAll uCalc]; %#ok<AGROW>
    
    if t(1) < 0, break, end
end

%% Calc Targed Values
% if a simulation completed successfully

if t(1) >= 0 && abs(t(end) - Numbers.timePoints(end)) < 10^-15
    
    goalVector = [];
    
    for k = 1:Numbers.goal
        u1 = [uCalcAll(:,Numbers.timeFitComp(k)),Numbers.actTimeCourse(:,k)];
        u1((u1(:,2)==0),:) = [];
        
        switch ForODE2.weight
            case 0, eachResid = u1(:,1)-u1(:,2);                 % weight 1
            case 1, eachResid = (u1(:,1)-u1(:,2))./u1(:,2).^0.5; % weight 1/Y
            case 2, eachResid = (u1(:,1)-u1(:,2))./u1(:,2);      % weight 1/Y^2
                %case 3, calcResid(k) = log((u1(:,1)-u1(:,2)).^2));  % weight log
        end
        
        goalVector = [goalVector,eachResid']; %#ok<AGROW>
    end
    
else
    goalVector = ones(1,numel(Numbers.u_goal)) * Inf;
    
    if t(1) == -8
        space = repmat(' ',1,max(0,3-numel(num2str(Numbers2.kParDiv))));
        disp([' ---------- Calculation of ',...
            '#',num2str(Numbers2.kParDiv),space,...
            ' stopped at ',num2str(t(2)),' of ',num2str(t(3))])
    else
        disp([' - t(1) == ',num2str(t(1))])
    end
    
end

%round([Numbers2.parDiv goalVector*goalVector']) %#ok<NOPRT>

end
