function [AIC,calcSS] = calcAIC(u,Numbers,ForODE)

calcSS = 0;

for k = 1:Numbers.goal
  u1 = [u(:,Numbers.timeFitComp(k)) Numbers.actTimeCourse(:,k)];
  
  u1(1,:) = [];
  u1((u1(:,2)==0),:) = [];
  
  switch ForODE.weight
    case 0, eachSS = sum((u1(:,1)-u1(:,2)).^2);            % weight 1
    case 1, eachSS = sum((u1(:,1)-u1(:,2)).^2./u1(:,2));   % weight 1/Y
    case 2, eachSS = sum(((u1(:,1)-u1(:,2))./u1(:,2)).^2); % weight 1/Y^2
    case 3, eachSS = sum(log((u1(:,1)-u1(:,2)).^2));       % weight log
  end
  
  calcSS = eachSS + calcSS;
end

AIC = log(calcSS) * (size(Numbers.timePoints,2)-1) + 2 * Numbers.xfree;

end