function y_out = calcY_stars(t,u,y_outEq,Numbers)
%Calculate y_star automatically from time-couse
%   Detailed explanation goes here

global aZero numbersCompCalc tutend extrapolateAUCinf
global tCalcEach uCalcEach


%% Prepare parameters
aZero             = Numbers.actTC_addZero;
numbersCompCalc   = size(u,2);
extrapolateAUCinf = Numbers.extrapolateAUCinf;
y_out             = zeros(1,numbersCompCalc);

% Ignore imaginary numbers
uCalc = real(u);


%% Calculate y_stars
cd('ystar')

% calc y_out if a simulation completed successfully
if t(end)==Numbers.timePoints(end)
    
    for k=1:numbersCompCalc
        
        tCalcEach = t(    Numbers.tCalcInd{k});
        uCalcEach = uCalc(Numbers.tCalcInd{k},k);
        
        tendindex = min([size(uCalcEach,1), ...
            find(uCalcEach>(max(uCalcEach)*Numbers.extrapolateAUCthres),...
            1,'last')]);
        tutend = [tCalcEach(1:tendindex),uCalcEach(1:tendindex,:)];
        
        y_out(k) = eval([char(y_outEq(k)) num2str(k) ')']);
        
        %y_outEq(k), [char(y_outEq(k)) num2str(k) ')']
    end
    
    
else

    for k=1:numbersCompCalc
        y_out(k) = Inf;
    end
end
cd('../')

end



function test %#ok<DEFNU>

t       = [0;1;2;3];
u       = [0,0;5,4;3,2;1,1];
u = [u,u,u,u(:,1),u(:,1)];
y_outEq = {'AUCtau(2,','AUCt0tau(2,','AUCt0inf(','AUCinf(',...
    'cmax(','kel(','AUC(','AUC('};

Numbers = struct;
Numbers.timePoints    = [0;1;2;3];
Numbers.actTC_addZero = 1;
Numbers.extrapolateAUCthres = 0.001;
Numbers.extrapolateAUCinf   = 3;
Numbers.tCalcInd = {...
    [1;2;3;4],[1;2;3;4],[1;2;3;4],[1;2;3;4],...
    [1;2;3;4],[1;2;3;4],[1;2;3;4],[1;2;3]};

y_out = calcY_stars(t,u,y_outEq,Numbers) %#ok<NASGU,NOPRT>
%y_out = [6.5000, 3.0000, 7.2427, 7.9427, 5.0000, 0.6931]

end