function [x,stopCalc,l_parameterOutofRange2,errState] = fixWithInRangeParameters(x,Numbers,ParaInd,IniXY,S)

errState = 0;
stopCalc = 0;
krepeat=0;
l_parameterInRange=0;
l_parameterOutofRange=1;
l_parameterOutofRange2=0;
while l_parameterOutofRange>0
    X_index = zeros(size(x));
    X_minindex = zeros(Numbers.xmin,size(x,2));
    X_maxindex = zeros(Numbers.xmax,size(x,2));
    
    xExp=x;
    xExp(ParaInd.expDist,:) = exp(x(ParaInd.expDist,:));
    if IniXY.strictLowLim
        xExp(ParaInd.min,:) = ...
            xExp(ParaInd.min,:) + repmat(IniXY.freelim(1,ParaInd.min),Numbers.samp,1)';
    end
    xmin = xExp(ParaInd.min,:);
    xmax = xExp(ParaInd.max,:);
    

    
    
    for kmin = 1:Numbers.xmin
        X_minindex(kmin,(xmin(kmin,:) <= IniXY.freelim(1,ParaInd.min(kmin))))=1;
    end
    for kmax = 1:Numbers.xmax
        X_maxindex(kmax,(xmax(kmax,:) >= IniXY.freelim(2,ParaInd.max(kmax))))=2;
    end
    X_index(ParaInd.min,:) = X_minindex;
    X_index(ParaInd.max,:) = X_index(ParaInd.max,:)+X_maxindex;
    
    outOfRange_index=find((sum(X_index,1))~=0);
    
    l_parameterOutofRange=size(outOfRange_index,2);
    if krepeat==0, l_parameterOutofRange2=l_parameterOutofRange; end
    
    if l_parameterOutofRange==0,break;end
    
    inRange_index=find((sum(X_index,1))==0);
    l_parameterInRange=size(inRange_index,2);
    
    if l_parameterInRange==0
        %error('No samples in parameter ranges')
        'No samples in parameter ranges' %#ok<NOPRT>
        
        if IniXY.strictLowLim
            'xExp(ParaInd.min,1:10)'
            disp(xExp(ParaInd.min,1:10))
        end
        
        sum(X_index,2)
        %stopCalc = 1;
        [x,stopCalc] = fix_devideS(x,Numbers,ParaInd,IniXY,S);
        if stopCalc ==1, errState = 5; end
        break;
    end
    
    inRangeXmean = sum(x(:,inRange_index),2)/l_parameterInRange;
    
    krepeat=krepeat+1;
    
    x(:,outOfRange_index)=(x(:,outOfRange_index)+repmat(inRangeXmean,1,l_parameterOutofRange))/2;
    
end

if l_parameterOutofRange2*l_parameterInRange ~=0, l_parameterOutofRange2, end %#ok<NOPRT>
end

function [x,stopCalc] = fix_devideS(x,Numbers,ParaInd,IniXY,S)
stopCalc = 0;
krepeat=0;
l_parameterOutofRange=1;
%l_parameterOutofRange2=0;
while l_parameterOutofRange>0
    X_index = zeros(size(x));
    X_minindex = zeros(Numbers.xmin,size(x,2));
    X_maxindex = zeros(Numbers.xmax,size(x,2));
    
    xExp=x;
    xExp(ParaInd.expDist,:) = exp(x(ParaInd.expDist,:));
    xmin = xExp(ParaInd.min,:);
    xmax = xExp(ParaInd.max,:);
    
    for kmin = 1:Numbers.xmin
        X_minindex(kmin,(xmin(kmin,:) <= IniXY.freelim(1,ParaInd.min(kmin))))=1;
    end
    for kmax = 1:Numbers.xmax
        X_maxindex(kmax,(xmax(kmax,:) >= IniXY.freelim(2,ParaInd.max(kmax))))=2;
    end
    X_index(ParaInd.min,:) = X_minindex;
    X_index(ParaInd.max,:) = X_index(ParaInd.max,:)+X_maxindex;
    Outofrange_index=find((sum(X_index,1))~=0);
    l_parameterOutofRange=size(Outofrange_index,2);
    
    if l_parameterOutofRange==0,break;end
    
    krepeat=krepeat+1;
    S=S./2;
    x(:,Outofrange_index)=x(:,Outofrange_index)-S(:,Outofrange_index);
    
    %if krepeat==1, l_parameterOutofRange2=l_parameterOutofRange; end
    if krepeat>100, stopCalc = 1; break; end
end

end