function [XforCalculation,l_a,stopCalc,errState,tcell1,ucell1,X,Y_k_half,sortedY,sortWithY] = ...
    twiceLSmethod(Model, resultFolder, IniXY, Numbers, ForODE, ParaInd, OtherSet, divID)

'Main calculation' %#ok<NOPRT>

%% Prepare parameters

[percRemainOrigSampInf,percRemainOrigSamp,X,Y,Y_k_half,A,tcell1,ucell1]=...
    prepParam(Numbers,IniXY,resultFolder,OtherSet.isDivSampRand);

%% Prepare X and Y for FIRST calculation
XforCalculation = prepareXforCalculation(Numbers,IniXY,ParaInd,X(:,:,1));
csvwrite([resultFolder 'InitialX.csv'], XforCalculation')

statusExport = ...
    [divID 1 Numbers.samp round(percRemainOrigSamp) round(percRemainOrigSampInf)] %#ok<NOPRT>
statusExport = [statusExport; zeros(1,5); ...
    XforCalculation(1:min(Numbers.samp,5),ParaInd.free)'...
    zeros(Numbers.xfree,max(0,5-Numbers.samp))];

k=1;

%% MAIN ROUTINE
while k < Numbers.iter + 1
    
    %% Solve system
    [Y_k_half,tcell1,ucell1,errState,stopCalc,parametersFILTerror]=...
        invokePBPK(Numbers,ForODE,XforCalculation,Model,tcell1,ucell1);
    Y_k_half(Y_k_half > 10^7) = Inf;
    
    %% Evaluate obtained answers
    [Y,l_a,l_inf,l_notinf,sortedY,sortWithY,...
        currentFit,statusExport,errState,stopCalc,Y_normalized]=...
        evalY(Y_k_half,Numbers,IniXY,Y,statusExport,errState,stopCalc,k,resultFolder); %#ok<ASGLU>
    
    plotDistXY(X,Y_normalized,k,OtherSet.isSaveYdist,ParaInd,resultFolder)
    
    if l_notinf(1)==0, break,end
    if k == Numbers.iter, break, end
    %if currentFit(1) < 0.01, break, end
    
    %% Inverse transformation
    
    [X,A,S,stopCalc,errState,l_parameterOutofRange2] = ...
        invTF(Numbers,IniXY,ParaInd,X,Y,Y_k_half,A,...
        l_inf,l_notinf,stopCalc,errState,...
        OtherSet.isDivSampRand,OtherSet.isDivSampDeltaS,OtherSet.deltaForS,k); %#ok<ASGLU>
    
    % No samples in parameter ranges
    if errState == 5 
        plotDistXY(X,1,k+1,OtherSet.isSaveYdist,ParaInd,resultFolder) 
    end
    
    if stopCalc ==1, break,end
    
    percRemainOrigSamp = percRemainOrigSamp * (1-(l_parameterOutofRange2)/Numbers.samp);
    percRemainOrigSampInf = percRemainOrigSampInf * l_notinf(1)/Numbers.samp;
    
    %save([resultFolder 'AXY'],'A','X','Y');
    
    
    %% Prepare X and Y for NEXT calculation
    Y_k_half=zeros(Numbers.goal,Numbers.samp);
    XforCalculation = prepareXforCalculation(Numbers,IniXY,ParaInd,X(:,:,k+1));
    
    
    %% Export status
    [divID, k+1, Numbers.samp, ...
        round(percRemainOrigSamp), round(percRemainOrigSampInf)] %#ok<NOPRT>
    
    statusExport = [statusExport; zeros(2,5); divID, k+1, Numbers.samp, ...
        round(percRemainOrigSamp), round(percRemainOrigSampInf); zeros(1,5); ...
        XforCalculation(1:min(Numbers.samp,5),ParaInd.free)' ...
        zeros(Numbers.xfree,max(0,5-Numbers.samp))]; %#ok<AGROW>
    
    csvwrite([resultFolder 'statusExport.csv'], statusExport)
    if sum(sum(XforCalculation))==Inf
        stopCalc =1; errState = 4;
         find(sum(XforCalculation,1)== Inf)
        'error: Parameter reached Inf', %#ok<NOPRT>
        plotDistXY(X,1,k+1,OtherSet.isSaveYdist,ParaInd,resultFolder)
        break,
    end
    if size(find(XforCalculation>10^10),1)~=0
        stopCalc = 1; errState = 7;
         find(sum(XforCalculation,1)>10^10)
        'Parameter values too large (>10^10)', %#ok<NOPRT>
        plotDistXY(X,1,k+1,OtherSet.isSaveYdist,ParaInd,resultFolder)
        break,
    end
    
    k = k +1;
    
end

save([resultFolder 'AXY'],'A','X','Y');

XforCalculation=XforCalculation';

%{
figure(4)
plot(log10(XforCalculation))
title('Distribution of X');

saveas(figure(2),[resultFolder 'distNormY.png'])
saveas(figure(3),[resultFolder 'sumY.png'])
saveas(figure(4),[resultFolder 'distX.png'])
            
%}

if numel(parametersFILTerror)~=0
    csvwrite([resultFolder 'parametersFILTerror.csv'], parametersFILTerror)
end

end



function [percRemainOrigSampInf,percRemainOrigSamp,X,Y,Y_k_half,A,tcell1,ucell1]=...
    prepParam(Numbers,IniXY,resultFolder,isDivSampRand)

percRemainOrigSampInf = 100; percRemainOrigSamp = 100;
%isAcuteAngle = 1; isAcuteAngleRep = 0;


X=zeros(Numbers.xfree,Numbers.samp,Numbers.iter);
X(:,:,1)=IniXY.xfree_distribution;
Y=zeros(Numbers.goal,Numbers.samp,Numbers.iter);
A=zeros(Numbers.goal, Numbers.xfree, Numbers.iter,isDivSampRand+1);
%not_inf_index = cell(1,Numbers.iter);
%Xdel=zeros(Numbers.xfree,Numbers.samp,Numbers.iter);
%Ydel=zeros(Numbers.goal,Numbers.samp,Numbers.iter);
%Y_o=zeros(Numbers.goal,Numbers.iter);
tcell1 = cell(Numbers.samp,1);
ucell1 = cell(Numbers.samp,1);

Y_k_half=zeros(Numbers.goal,Numbers.samp);

%save([resultFolder 'AXY'],'A','X','Y');

end




function [Y_k_half,tcell1,ucell1,errState,stopCalc,parametersFILTerror]=...
    invokePBPK(Numbers,ForODE,XforCalculation,Model,tcell1,ucell1)

errState = 0; stopCalc = 0;
errStateArray=zeros(Numbers.sepCond,Numbers.samp);

switch char(ForODE.calcAlgorithm(1))
    case {'ode','FILT','ode_mfile'}
        
        % Solve ODE or FILT
        
        Y_k_half = zeros(Numbers.goal,Numbers.samp);
        
        parfor k1=1:Numbers.samp
            Y_k_halfCalc = []; ufit = []; errStateArrayTemp = [];
            ticEach = tic;
            for k2 = 1:Numbers.sepCond %#ok<PFBNS>
                [youtCalc,t,uCalc]=...
                    PBPK_model(XforCalculation(k1,:), Model, Numbers, ForODE, k1, k2);
                
                sizeuCalc = size(uCalc,1);
                if sizeuCalc<size(Numbers.timePoints,2)
                    uCalc = [uCalc; ...
                        zeros(size(Numbers.timePoints,2)-sizeuCalc,Numbers.compAll(k2))];
                end
                
                ufit = [ufit uCalc];
                Y_k_halfCalc = [Y_k_halfCalc youtCalc];
                if t(1)~=0,  errStateArrayTemp = [errStateArrayTemp 5 - t(1)];
                else errStateArrayTemp = [errStateArrayTemp 0]; end
            end
            Y_k_half(:,k1) = Y_k_halfCalc';
            tcell1{k1}=Numbers.timePoints';
            ucell1{k1}=ufit;
            errStateArray(:,k1) = errStateArrayTemp';
            
            %disp([num2str(k1),' - ',num2str(toc(ticEach))]);
        end
        
    case 'odegpu'
        
        [tcell1,ucell1,Y_k_half] = invokeArrayFun(XforCalculation, Model, Numbers, ForODE);
        
    otherwise
        
        Y_k_half = zeros(Numbers.goal,Numbers.samp);
        
        parfor k1=1:Numbers.samp
            Y_k_halfCalc = [];
            for k2 = 1:Numbers.sepCond %#ok<PFBNS>
                youtCalc = solveOE(XforCalculation(k1,:), ForODE, k2);
                Y_k_halfCalc = [Y_k_halfCalc youtCalc];
            end
            Y_k_half(:,k1) = Y_k_halfCalc';
        end
end


% solveFILT errors
parametersFILTerror = [];
switch char(ForODE.calcAlgorithm(1))
    case 'FILT'
        if sum(sum(errStateArray)) ~= 0
            sum(sum(errStateArray))
            [errState,parametersFILTerror] = ...
                solveFILTerrors(errStateArray, Numbers.sepCond, ...
                parametersFILTerror, XforCalculation, k);
            stopCalc =1;
        end
end

tocf(6)
    
end




function XforCalculation = prepareXforCalculation(Numbers,IniXY,ParaInd,X_k_half)

XforCalculation = zeros(Numbers.samp,Numbers.xfree+Numbers.xfix);

%prepare X for calculation
%{
for k1=1:Numbers.samp
   
    XforCalculation(k1,ParaInd.fix) = IniXY.xfix(1:Numbers.xfix);
    XforCalculation(k1,ParaInd.free(ParaInd.normalDist)) = ...
        X_k_half(ParaInd.normalDist,k1);
    XforCalculation(k1,ParaInd.free(ParaInd.expDist)) = ...
        exp(X_k_half(ParaInd.expDist,k1));
    
    if IniXY.strictLowLim
        XforCalculation(k1,ParaInd.free(ParaInd.min)) = ...
            XforCalculation(k1,ParaInd.free(ParaInd.min)) + IniXY.freelim(1,ParaInd.min);
    end
end
%}

XforCalculation(:,ParaInd.fix) = repmat(IniXY.xfix(1:Numbers.xfix),Numbers.samp,1);
XforCalculation(:,ParaInd.free(ParaInd.normalDist))= X_k_half(ParaInd.normalDist,:)';
XforCalculation(:,ParaInd.free(ParaInd.expDist))   =exp(X_k_half(ParaInd.expDist,:)');

if IniXY.strictLowLim
    XforCalculation(:,ParaInd.free(ParaInd.min)) = ...
        XforCalculation(:,ParaInd.free(ParaInd.min)) + ...
        repmat(IniXY.freelim(1,ParaInd.min),Numbers.samp,1);
end

%XforCalculation(1:min(Numbers.samp,5),ParaInd.free)' %#ok<NOPRT>

end




function [Y,l_a,l_inf,l_notinf,sortedY,sortWithY,...
    currentFit,statusExport,errState,stopCalc,Y_normalized]=...
    evalY(Y_k_half,Numbers,IniXY,Y,statusExport,errState,stopCalc,k,resultFolder)

 
l_inf = zeros(3,1); l_notinf = zeros(3,1);

%% Find Inf samples
not_inf_index=find(sum(Y_k_half,1)~=Inf); inf_index=find(sum(Y_k_half,1)==Inf);
l_inf(1)=size(inf_index,2); l_notinf(1)=size(not_inf_index,2);

if l_notinf(1)==0
    stopCalc =1; errState = 1;
    'error: y_out of all samples reached Inf', %#ok<NOPRT>
    find(sum(Y_k_half~=Inf,2)==0)
    csvwrite([resultFolder 'Y_k_half.csv'], Y_k_half);
elseif l_inf(1) ~= 0
    disp(['Number of samples whose y reached Inf is ' num2str(l_inf(1)) '.'])
end 

%% Find NaN samples
nan_index = find(isnan(sum(Y_k_half,1)));
l_nan=size(nan_index,2);% l_notinf(1)=size(not_inf_index,2);
if l_nan~=0, l_nan,error('y_out reached NaN'), end %#ok<NOPRT>

Y(:,not_inf_index,k)=Y_k_half(:,not_inf_index);
  

%% Evaluate convergence
Y_index=zeros(Numbers.goal,l_notinf(1));
Y_normalized=diag(1./IniXY.y_star)*Y(:,not_inf_index,k);

Y_index(Y_normalized>1*Numbers.acc_y_folddiff)=1;
Y_index(Y_normalized<1/Numbers.acc_y_folddiff)=1;
if Numbers.goal==1
    Accept_index=find(Y_index==0);
else
    Accept_index=find(sum(Y_index)==0);
end
l_a=size(Accept_index,2);

Y_normalizedDiffSum = sum((Y_normalized-1).^2,1).^(1/2);
currentFit = ...
    [median(Y_normalizedDiffSum) sum(Y_normalizedDiffSum)/Numbers.samp ...
    min(Y_normalizedDiffSum) max(Y_normalizedDiffSum)] %#ok<NOPRT>

Y_normalized(:,Y_normalizedDiffSum==min(Y_normalizedDiffSum)) %#ok<NOPRT>

[sortedY,sortWithY] = sort(Y_normalizedDiffSum);
sortWithY = not_inf_index(sortWithY);


if  stopCalc == 0
  statusExport = [statusExport; zeros(1,5); currentFit 0];
end

end




function plotDistXY(X,Y_normalized,k,isSaveYdist,ParaInd,resultFolder)
    
saveInterval = isSaveYdist;
    
if isSaveYdist && k == floor((k-1)/saveInterval)*saveInterval+1
    
    figure(2)
    
    %% Plot X
    subplot(2,1,1)
    
    initXfree  = X(:,:,1);
    finalXfree = X(:,:,k);
    initXfree( ParaInd.expDist,:) = exp(initXfree( ParaInd.expDist,:));
    finalXfree(ParaInd.expDist,:) = exp(finalXfree(ParaInd.expDist,:));
    
    initXfree  = log10(initXfree)';
    finalXfree = log10(finalXfree)';
    normXfree  = initXfree;
    freeNum    = size(initXfree,2);
    
    
    [initXfree,finalXfree]=normalizeFinalX(initXfree,finalXfree,normXfree); %#ok<ASGLU>
    
    plot(1:freeNum,finalXfree');
    title('Distribution of normalized X');
    
    
    %% Plot Y
    subplot(2,1,2)
    
    plot(log10(Y_normalized))
    title('Distribution of normalized Y');
    
    
    %% Save fig
    saveas(figure(2),[resultFolder ['fig/distXY_' num2str(k) '.png']])
    
end

end




function [initXfree,finalXfree]=normalizeFinalX(initXfree,finalXfree,normXfree)

normXfreeMean  = (max(normXfree) + min(normXfree))/2;
normXfreeRange =  max(normXfree) - min(normXfree);
normXfreeRange = diag(1./normXfreeRange);


initXfree = ...
    (initXfree - repmat(normXfreeMean,size(initXfree,1),1))...
    *normXfreeRange*2;
finalXfree = ...
    (finalXfree - repmat(normXfreeMean,size(finalXfree,1),1))...
    *normXfreeRange*2;


end




function [errState,parametersFILTerror] = ...
    solveFILTerrors(errStateArray, sepCond, parametersFILTerror, XforCalculation,loopnumber)

errorsIndex = [6 7 8 9 10];
errState = 6;
errSampIndex = cell(size(errorsIndex));
errSampIndexDiff = cell(size(errorsIndex));

for k1 = errorsIndex
    errSampIndex{k1} = sort(ceil(find(errStateArray == 6)/sepCond))';
    if numel(errSampIndex{k1})~=0
        errSampIndexDiff{k1} = [1 diff(errSampIndex{k1})];
        errSampIndex{k1} = errSampIndex{k1}(errSampIndexDiff{k1}~=0);
        
        parametersFILTerror = ...
            [parametersFILTerror; 6 k1 zeros(1,size(XforCalculation,2))]; %#ok<AGROW>
        for k2 = 1:size(errSampIndex{k1},2)
            parametersFILTerror = ...
                [parametersFILTerror; ...
                [loopnumber errSampIndex{k1}(k2) ...
                XforCalculation(errSampIndex{k1}(k2),:)]]; %#ok<AGROW>
        end
    end
end

end



function [X,A,S,stopCalc,errState,l_parameterOutofRange2] = ...
    invTF(Numbers,IniXY,ParaInd,X,Y,Y_k_half,A,...
    l_inf,l_notinf,stopCalc,errState,isDivSampRand,isDivSampDeltaS,deltaForS,k)

%% Divide samples if isDivSampRand
if isDivSampRand
    inf_indexC = cell(1,2);
    
    [randNum,randIndex] =sort(rand(1,Numbers.samp)); %#ok<ASGLU>
    oldID = find(randIndex <= (Numbers.samp+1)/2);
    oldID(2,:) = find(randIndex >  (Numbers.samp+1)/2); %#ok<NASGU>
    
    X_k_half        = X(:,randIndex <= Numbers.samp/2,k);
    X_k_half(:,:,2) = X(:,randIndex >  Numbers.samp/2,k);
    
    Y_k_half2        = Y_k_half(:,randIndex <= Numbers.samp/2);
    Y_k_half2(:,:,2) = Y_k_half(:,randIndex >  Numbers.samp/2);
    
else
    inf_indexC = cell(1,1);
    X_k_half = X(:,:,k);
    Y_k_half2  = Y_k_half;
end

%% Create S and new X
for k2 = 1:(1+isDivSampRand)
    
    not_inf_index=find(sum(Y_k_half2(:,:,k2),1)~=Inf);
    inf_index=find(sum(Y_k_half2(:,:,k2),1)==Inf);
    l_inf(k2+1)=size(inf_index,2); l_notinf(k2+1)=size(not_inf_index,2);
    
    X_k_halfDiv = X_k_half(:,not_inf_index,k2);
    Y_k_halfDiv = Y_k_half2(:,not_inf_index,k2);
    
    X_temp=[X_k_halfDiv; ones(1,l_notinf(k2+1))];
    
    %[size(Y_k_halfDiv) size([A(:,:,k,k2),ones(Numbers.goal,1) ]*X_temp)] %#ok<NOPRT>
    
    A_temp=(pinv(X_temp')*(Y_k_halfDiv-([A(:,:,k,k2),ones(Numbers.goal,1) ]*X_temp))')'...
        +[A(:,:,k,k2),ones(Numbers.goal,1)];
    
    A(:,:,k+1,k2)=A_temp(:,1:Numbers.xfree);
    %Y_o(:,k+1)=A_temp(:,Numbers.xfree+1);
    
    % Y_star +- 102.5% distribution
    Y_star=repmat(IniXY.y_star',1,Numbers.samp/(1+isDivSampRand));
    Y_star=Y_star.*((rand(Numbers.goal,Numbers.samp/(1+isDivSampRand))-1/2)*10^(-1)/2+1);
    
    %Manage notcalc_index2 with linear combination of successful samples
    XforCalc = X_k_half(:,:,k2);
    if size(inf_indexC{k2},2) ~=0
        XnotInf = XforCalc(:,not_inf_index);
        rand_val=rand(l_notinf(k2+1),l_inf(1));
        rand_val_normalized = rand_val * diag(1./sum(rand_val));
        
        Xreplace = (XnotInf * rand_val_normalized);
        XforCalc(:,inf_index) = Xreplace;
    end
    
    S = A(:,:,k+1,k2)'*...
        (pinv(A(:,:,k+1,k2)*A(:,:,k+1,k2)')*...
        (Y_star-A_temp*[XforCalc; ones(1,Numbers.samp/(1+isDivSampRand))]));
    if (rcond(A(:,:,k+1,k2)*A(:,:,k+1,k2)') < 10^(-23)),
        'error: RCOND too low',  %#ok<NOPRT>
        [stopCalc,errState,paramYoutCorrMatrix] = ...
            RCONDtoolow(Numbers,X,Y,not_inf_index,k); %#ok<NASGU>
        %csvwrite([resultFolder 'paramYoutCorrMatrix.csv'], paramYoutCorrMatrix)
        l_parameterOutofRange2=0;
        break;
    end
    
    if isnan(A(:,:,k+1,k2)*A(:,:,k+1,k2)'), stopCalc =1; errState = 3;...
            'error: RCOND equals NaN', break, end %#ok<NOPRT>
    X_k_half(:,:,k2) = S + XforCalc;
    
    [X_k_half(:,:,k2),stopCalc,l_parameterOutofRange2,errState] =...
        fixWithInRangeParameters(X_k_half(:,:,k2),Numbers,ParaInd,IniXY,S);
    
end


if isDivSampDeltaS
    k2 = 2;
    XforCalcS = deltaForS * S + XforCalc;
    
    S = A(:,:,k+1,1)'*...
        (pinv(A(:,:,k+1,1)*A(:,:,k+1,1)')*...
        (Y_star-A_temp*[XforCalcS; ones(1,Numbers.samp/(1+isDivSampRand))]));
    
    %S(1:3,1:4,1)
    
    X_k_half(:,:,k2)  = S + XforCalc;
    
    [X_k_half(:,:,k2),stopCalc,l_parameterOutofRange2,errState] =...
        fixWithInRangeParameters(X_k_half(:,:,k2),Numbers,ParaInd,IniXY,S);
end

%X(1:4,1:4,k)
%X_k_half(1:3,1:4,1)
%X_k_half(1:3,1:4,2)


if isDivSampRand
    X(:,:,k+1) = [X_k_half(:,:,1) X_k_half(:,:,2)];
elseif isDivSampDeltaS
    randNum = rand(1,Numbers.samp);
    X(:,randNum >  0.5,k+1) = X_k_half(:,randNum >  0.5,1);
    X(:,randNum <= 0.5,k+1) = X_k_half(:,randNum <= 0.5,2);
else
    X(:,:,k+1) =  X_k_half;
end


end




function [stopCalc,errState,paramYoutCorrMatrix] = ...
    RCONDtoolow(Numbers,X,Y,not_inf_index,k)

stopCalc = 1;
errState = 2;
paramYoutCorrMatrix = zeros(Numbers.xfree,Numbers.goal + 1);
for kcmp = 1:Numbers.xfree
    paramYoutCorr = corrcoef([X(kcmp,not_inf_index,k)' Y(:,not_inf_index,k)']);
    paramYoutCorrMatrix(kcmp,:) = paramYoutCorr(1,:);
end
paramYoutCorrMatrix(:,1) = [];

end




function [tcell1,ucell1,Y_k_half] = invokeArrayFun(XforCalculation, Model, Numbers, ForODE)

global ModelArr NumbersArr ForODEArr

ModelArr = Model;
NumbersArr = Numbers;
ForODEArr = ForODE;
       
Y_k_half = zeros(Numbers.goal,Numbers.samp);
x = cell(Numbers.samp,1);
loopNumber = cell(Numbers.samp,1);

for k1 = 1:Numbers.samp
    x{k1} = XforCalculation(k1,:);
    loopNumber{k1} = k1;
end

[Y_k_halfcell,tcell1,ucell1] = arrayfun(@PBPK_model_Arr,x,loopNumber);
        
for k1 = 1:Numbers.samp
    Y_k_half(:,k1) = Y_k_halfcell{k1};
end

end




function [Y_k_halfcell,tcell1,ucell1] = PBPK_model_Arr(x,loopNumber)
global ModelArr NumbersArr ForODEArr

Y_k_halfCalc = []; ufit = [];
x = x{1}; loopNumber = loopNumber{1};

for k2 = 1:NumbersArr.sepCond
    [youtCalc,t,uCalc] = ...
        PBPK_model(x, ModelArr, NumbersArr, ForODEArr, loopNumber, k2);   %#ok<ASGLU>
    
    ufit = [ufit uCalc]; %#ok<AGROW>
    Y_k_halfCalc = [Y_k_halfCalc youtCalc]; %#ok<AGROW>
    
end

Y_k_halfcell{1} = Y_k_halfCalc';
tcell1{1} = NumbersArr.timePoints';
ucell1{1} = ufit;

end