function main(calcSet, Setting, id)
% calcSet - 1: dS, 2: repeat, 3: list, 4: RPG, 5: multi, 6: beta


%% Settings
if nargin == 0
    cd('setting');
    Setting = struct;
    Setting = setting(Setting);
    Setting.calcSet = 0;
    cd('../');
    
else
    Setting.calcSet = calcSet;
    switch Setting.calcSet
        case {1,3,4,5}
            Setting.comment = num2str(id);
        case 2 
            Setting.comment = id;
    end
    
    if Setting.calcSet == 1
        dS = id;
        Setting.deltaForS = (dS-1) / 10;
        Setting.iterdS = dS;
    end
end



Setting.Model
if exist(['../Model/',Setting.Model],'dir') ~= 7
   error(['No designated model files: ',Setting.Model]) 
end


if Setting.isDivSampRand + Setting.isDivSampDeltaS > 1
    error('Select isDivSamp XOR isDivSampDeltaS')
end


%% Prepare folders

switch Setting.calcSet
    case {3,4,5}
        resultFolder = Setting.resultFolder;
    case 2
        Setting.setFile = 'setting.m';
        cd('setting');
        [resultFolder,calcID] = ...
            prepareFolder(Setting,'', Setting.comment); %#ok<NASGU>
        cd('../');
    otherwise
        Setting.setFile = 'setting.m';
        cd('setting');
        [resultFolder,calcID] = prepareFolder(Setting,''); %#ok<NASGU>
        cd('../');
end


%% Prepare parameters

cd('import');
parameters = ...
    str2double(importStr(['../../Model/',Setting.Model, '/','Parameters.csv'], ','))';
cd('../');

[InitialXY,ParameterIndex] = impParForDiv(parameters);

cd('parameterPrep');
InitialXY.isDivOverlap  = Setting.isDivOverlap;
InitialXY.paramDivDirec = Setting.paramDivDirec;
[xfreeDivArray,xfreeDivIndex,xDivIsFit,divideNumberProd]=...
    divParamRange(InitialXY, ParameterIndex, resultFolder); %#ok<ASGLU>
cd('../');

if divideNumberProd>32
    error('Parameter division# too large')
end



%% Submit job

for k = 1:divideNumberProd
    
    Setting.resultFolder = [resultFolder num2str(k) '/'];
    mkdir(Setting.resultFolder)
    
    %Save divided parameters for each result folder
    parameters(1:2,ParameterIndex.free(ParameterIndex.divPar))=...
        xfreeDivArray((k*2-1:k*2),:);
    csvwrite([Setting.resultFolder 'Parameters.csv'], parameters')
    
    Setting.xfreeDivArray = xfreeDivArray((k*2-1):k*2,:);
    
    save([Setting.resultFolder 'Setting.mat'], 'Setting')
    disp(['# in parameter separation:' num2str(k)])
    
    mainCal(k,Setting)
end




if Setting.calcSet == 0
    matlabpool size, if ans ~= 0, matlabpool close; end %#ok<NOANS>
end 

end








function [InitialXY,ParameterIndex] = impParForDiv(parameters)

InitialXY = struct; ParameterIndex = struct;

ParameterIndex.free=find(parameters(3,:)~=0);
ParameterIndex.fix=find(parameters(3,:)==0);
ParameterIndex.min=...
    find(parameters(3,ParameterIndex.free)==2|parameters(3,ParameterIndex.free)==4);
ParameterIndex.max=...
    find(parameters(3,ParameterIndex.free)==3|parameters(3,ParameterIndex.free)==4);
ParameterIndex.normalDist=find(parameters(6,ParameterIndex.free)~=1);
ParameterIndex.expDist=find(parameters(6,ParameterIndex.free)==1);
ParameterIndex.divPar=find(parameters(7,ParameterIndex.free)>1);
InitialXY.xDivNum = parameters(7,ParameterIndex.free);
ParameterIndex.divParExp=...
    find(parameters(6,ParameterIndex.free(ParameterIndex.divPar))==1);

InitialXY.freelimits = parameters(4:5,ParameterIndex.free);
InitialXY.xfree_import = parameters(1:2,ParameterIndex.free); %initial min&max
InitialXY.xfree_import(1:2,ParameterIndex.expDist) = ...
    log(InitialXY.xfree_import(1:2,ParameterIndex.expDist));
InitialXY.xfix = parameters(1,ParameterIndex.fix);%parameters for fixed

end
