function mainLM

%% Settings

cd('setting');
Setting = struct;
Setting.setFile = 'setting_LM.m';
Setting.calcType = 'mainLM';
Setting = setting_LM(Setting);
cd('../');

if exist(['../Model/',Setting.Model],'dir') ~= 7
   error(['No designated model files: ',Setting.Model]) 
end


%% Parameter and folder preparation

cd('setting');
[resultFolderParent,calcID] = ...
    prepareFolder(Setting,'LM'); %#ok<NASGU>
Setting.resultFolderParent = resultFolderParent;
cd('../');


[x_out,AIC] = callMainLMeach(Setting); %#ok<NASGU,ASGLU>

end



function [x_out,AIC] = callMainLMeach(SettingParent,condNum,modelAdd,foldAdd) %#ok<INUSL>

Setting = SettingParent;

if nargin == 1  
    Setting.Model  = [Setting.Model];
    resultFolder   = [SettingParent.resultFolderParent];
elseif nargin == 4
    Setting.Model  = [Setting.Model modelAdd];
    resultFolder   = [SettingParent.resultFolderParent, foldAdd];
    mkdir(resultFolder)
end


cd('import');
parameters = csvread(['../../Model/', Setting.Model,'/','Parameters_LM.csv'])';
cd('../');

csvwrite(['../Model/', Setting.Model,'/','Parameters_LM.tmp.csv'], parameters')

cd('calc');
[x_out,AIC] = mainLMeach(resultFolder,Setting,parameters);
cd('../');


end
