function mainList

cd('setting');
modelListFolders = setting_list;
cd('../');

for k = 1:numel(modelListFolders)
    mainList_run(modelListFolders{k})
end

matlabpool size, if ans ~= 0, matlabpool close; end %#ok<NOANS>
    
end


function mainList_run(modelListFolder)

cd('setting');
Setting = struct;
Setting = setting(Setting);
cd('../');

Setting.useTemp     = 1;
Setting.isSaveYdist  = 1;

Setting.iter=   15;
Setting.samp=   2000;

%% Import Model list
modelC       = cell(0);
modelCline   = cell(0);
modelCimport = cell(0);

fid = fopen(['../Model/',modelListFolder,'/list.txt']);
tline = fgets(fid);

while ischar(tline)
    modelCline{end+1} = strtrim(tline); %#ok<AGROW>
    tline = fgets(fid);
end

fclose(fid);

for k = 1:numel(modelCline)
    if strcmp(modelCline{k},'') == 0
        
        modelC{end+1}       = [modelListFolder,'/',modelCline{k}]; %#ok<AGROW>
        modelCimport{end+1} =                      modelCline{k};  %#ok<AGROW>
        
        if exist(['../Model/',modelC{end}],'dir') ~= 7
            error(['No designated model files: ',modelC{end}])
        end
        
        disp(modelC{end})
    end
end





%% Settings

calcTypeList = {'1-main','2-noMet'};

Setting.saveFm  = 2;



%% Run
[~,Setting.comment] = saveComment;
Setting.setFile = 'setting.m';

cd('setting');
Setting.Model = modelListFolder;
resultFolderForList = prepareFolder(Setting,'',Setting.comment);
cd('../');

copyfile(['../Model/',modelListFolder,'/0-Data_base.xlsx'],resultFolderForList); 
copyfile(['../Model/',modelListFolder,'/list.txt']        ,resultFolderForList); 


for kModel = 1:numel(modelC)
    
    Setting.Model = modelC{kModel};
                   
    if exist(['../Model/',Setting.Model,'/onlyAUC.txt']) %#ok<EXIST>
        onlyAUC  = csvread(['../Model/',Setting.Model,'/onlyAUC.txt']);
    else
        onlyAUC = 0;
    end 
    
    Setting.onlyAUC = onlyAUC(1);
    
    for kSet = 1:2
        
        Setting.noMetabolite = kSet*2 - 2;
        Setting.calcTypeList = calcTypeList{kSet};
        disp(calcTypeList{kSet})
        
        switch kSet
            case 1
                copyfile(['../Model/',Setting.Model,'/ActualTimeCourse.csv'],...
                    ['../Model/',Setting.Model,'/ActualTimeCourse.tmp.csv']);
                copyfile(['../Model/',Setting.Model,'/y_outEq1.txt'],...
                    ['../Model/',Setting.Model,'/y_outEq1.tmp.txt']);
                if exist(['../Model/',Setting.Model,'/y_star.csv']) %#ok<EXIST>
                    copyfile(['../Model/',Setting.Model,'/y_star.csv'],...
                        ['../Model/',Setting.Model,'/y_star.tmp.csv']);
                end
            case 2
                copyfile(['../Model/',Setting.Model,'/ActualTimeCourse_noMet.csv'],...
                    ['../Model/',Setting.Model,'/ActualTimeCourse.tmp.csv']);
                copyfile(['../Model/',Setting.Model,'/y_outEq1_noMet.txt'],...
                    ['../Model/',Setting.Model,'/y_outEq1.tmp.txt']);
                if exist(['../Model/',Setting.Model,'/y_star_noMet.csv']) %#ok<EXIST>
                    copyfile(['../Model/',Setting.Model,'/y_star_noMet.csv'],...
                        ['../Model/',Setting.Model,'/y_star.tmp.csv']);
                end
        end
        
        
        repNum = 0;
        while repNum < 3
            
            Setting.resultFolder = [...
                resultFolderForList,...
                modelCimport{kModel},'/',...
                calcTypeList{kSet},'/'...
                ];
            mkdir(Setting.resultFolder);
            
        
            main(3, Setting, ['list-',Setting.comment])
            
            if exist([Setting.resultFolder,'1/finalXY/FinalXYsortY.mat'],'file')
                repNum = 3;
            else
                movefile([Setting.resultFolder,'1/'],...
                    [Setting.resultFolder,'1_',num2str(repNum),'/']);
                repNum = repNum + 1;
            end
        end
        
    end
end



end




function [commentSave,commentHead] = saveComment

commentSave = input('Comment?: ','s');
if isempty(commentSave)
    commentHead = [];
else
    blankIndex = strfind(commentSave, ' ');
    if isempty(blankIndex)
        commentHead = commentSave;
    else
        commentHead = commentSave(1:(blankIndex-1));
    end
end

end
