function mainMulti

modelListFolders{1}  = 'didb_multi';

for k = 1:numel(modelListFolders)
    mainMulti_run(modelListFolders{k})
end

matlabpool size, if ans ~= 0, matlabpool close; end %#ok<NOANS>


end

function mainMulti_run(modelListFolder)

cd('setting');
Setting = struct;
Setting = setting(Setting);
cd('../');

Setting.cDate  = datestr(now, 'yyyymmdd-HHMM');
Setting.cMonth = datestr(now, 'yyyymm');

Setting.useTemp     = 1;
Setting.isSaveYdist = 1;


%% Import Model list
modelC       = cell(0);
modelCline   = cell(0);
modelCimport = cell(0);

fid = fopen(['../Model/',modelListFolder,'/list.txt']);
tline = fgets(fid);

while ischar(tline)
    modelCline{end+1} = strtrim(tline); %#ok<AGROW>
    tline = fgets(fid);
end

fclose(fid);

for k = 1:numel(modelCline)
    if strcmp(modelCline{k},'') == 0
        
        modelC{end+1}       = [modelListFolder,'/',modelCline{k}]; %#ok<AGROW>
        modelCimport{end+1} =                      modelCline{k};  %#ok<AGROW>
        
        if exist(['../Model/',modelC{end}],'dir') ~= 7
            error(['No designated model files: ',modelC{end}])
        end
        
        disp(modelC{end})
    end
end





%% Settings

calcTypeList = {'1-main','2-noMet'};

Setting.saveFm  = 1;



%% Run
[~,Setting.comment] = saveComment;
Setting.setFile = 'setting.m';

cd('setting');
Setting.Model = modelListFolder;
resultFolderForList = prepareFolder(Setting,'',Setting.comment);
cd('../');

copyfile(['../Model/',modelListFolder,'/list.txt'] ,resultFolderForList); 


for kModel = 1:numel(modelC)
    
    Setting.Model   = modelC{kModel};
                   
    if exist(['../Model/',Setting.Model,'/onlyAUC.txt'])
        onlyAUC  = csvread(['../Model/',Setting.Model,'/onlyAUC.txt']);
    else
        onlyAUC = 0;
    end 
    
    Setting.onlyAUC = onlyAUC(1);
    
    repNum = [1,1];
    
    for kSet = [2,1]
        
        Setting.noMetabolite = kSet - 1;
        Setting.calcTypeList = calcTypeList{kSet};
        disp(calcTypeList{kSet})
        
        
        for krep=1:repNum(kSet)
            
            switch kSet
                case 1
                    copyfile(['../Model/',Setting.Model,'/ActualTimeCourse.csv'],...
                        ['../Model/',Setting.Model,'/ActualTimeCourse.tmp.csv']);
                    copyfile(['../Model/',Setting.Model,'/y_outEq1.txt'],...
                        ['../Model/',Setting.Model,'/y_outEq1.tmp.txt']);
                    if exist(['../Model/',Setting.Model,'/y_star.csv'])
                        copyfile(['../Model/',Setting.Model,'/y_star.csv'],...
                            ['../Model/',Setting.Model,'/y_star.tmp.csv']);
                    end
                case 2
                    copyfile(['../Model/',Setting.Model,'/ActualTimeCourse_noMet.csv'],...
                        ['../Model/',Setting.Model,'/ActualTimeCourse.tmp.csv']);
                    copyfile(['../Model/',Setting.Model,'/y_outEq1_noMet.txt'],...
                        ['../Model/',Setting.Model,'/y_outEq1.tmp.txt']);
                    if exist(['../Model/',Setting.Model,'/y_star_noMet.csv'])
                        copyfile(['../Model/',Setting.Model,'/y_star_noMet.csv'],...
                            ['../Model/',Setting.Model,'/y_star.tmp.csv']);
                    end
            end
            
            
            
            Setting.resultFolder = [...
                resultFolderForList,...
                modelCimport{kModel},'/',...
                calcTypeList{kSet},'_',num2str(krep),'/'...
                ];
            mkdir(Setting.resultFolder);
            
        
            main(5, Setting, ['list-',Setting.comment])
            
            if exist([Setting.resultFolder,'1/finalXY/FinalXYsortY.mat'],'file')
                simulationMulti(Setting.Model,Setting.resultFolder,Setting.samp,10)
            end
        end
    end
end



end




function [commentSave,commentHead] = saveComment

commentSave = input('Comment?: ','s');
if isempty(commentSave)
    commentHead = [];
else
    blankIndex = strfind(commentSave, ' ');
    if isempty(blankIndex)
        commentHead = commentSave;
    else
        commentHead = commentSave(1:(blankIndex-1));
    end
end

end
