function [xfreeDivArrayReturn,xfreeDivIndex,xDivIsFit,divideNumberProd] = ...
    divParamRange(InitialXY, ParameterIndex, resultFolder)
% Separate parameter range in multiple ranges of given numbers.
% When the given number is n, the final number of range is 2*n-1.
%
% k3th range has values of min + (k3-1)*divRange -> min + (k3+1)*divRange.
% Total calculation number is given in divideNumberProd.

%InitialXY.isDivOverlap = 0; %0- no overlap and just separate, 1 - overlap
divParNum = size(ParameterIndex.divPar,2);

%InitialXY.xfree_import
xFreeDiv = InitialXY.xfree_import(:,ParameterIndex.divPar);
xDivNum = InitialXY.xDivNum(:,ParameterIndex.divPar);

if InitialXY.isDivOverlap ==0
    divideNumbers = xDivNum; %Actual range numbers
elseif  InitialXY.isDivOverlap ==1
    divideNumbers = xDivNum*2-1; %Actual range numbers
end

divRange = (xFreeDiv(2,:) - xFreeDiv(1,:))./(divideNumbers + InitialXY.isDivOverlap);
divideNumberProd = prod(divideNumbers);%Total cases
divideNumberProdCalc = 1; %Initial value

%Prepare 2*(parameter number) Matrix
xfreeDivArray = zeros(2,divParNum);
xfreeDivIndex = zeros(1,divParNum);

%k1: position x, k2: size of previous array,
%k3: number of divisions for each x
for k1 = 1:divParNum
    xfreeDivArray3 =[]; xfreeDivIndex3 = [];
    for k2 = 1:divideNumberProdCalc %size of array in the previous parameter
        %prepare array to assign parameters
        xfreeDivArray2 = repmat(xfreeDivArray((k2*2-1):k2*2,:),divideNumbers(k1),1);
        xfreeDivIndex2 = repmat(xfreeDivIndex(k2,:),divideNumbers(k1),1);
        
        for k3 = 1:divideNumbers(k1)-1
            xfreeDivArray2(k3*2-1,k1) = xFreeDiv(1,k1) + divRange(k1) * (k3 - 1);
            xfreeDivArray2(k3*2,k1)   = xFreeDiv(1,k1) + divRange(k1) * (k3 + InitialXY.isDivOverlap);
            xfreeDivIndex2(k3,k1) = k3;
        end
        %final division
        xfreeDivArray2(divideNumbers(k1)*2-1,k1) = xFreeDiv(1,k1) + divRange(k1) * (divideNumbers(k1)-1);
        xfreeDivArray2(divideNumbers(k1)*2,k1) = xFreeDiv(2,k1);
        xfreeDivIndex2(divideNumbers(k1),k1) = divideNumbers(k1);
        
        xfreeDivArray3 = [xfreeDivArray3; xfreeDivArray2];  %#ok<AGROW>
        xfreeDivIndex3 = [xfreeDivIndex3; xfreeDivIndex2];  %#ok<AGROW>
    end
    xfreeDivArray = xfreeDivArray3;
    xfreeDivIndex = xfreeDivIndex3;
    divideNumberProdCalc = divideNumberProdCalc * divideNumbers(k1);
end

if InitialXY.paramDivDirec
    xfreeDivArray = xfreeDivArray(divideNumberProd*2:-1:1,:);
    for k = 1:divideNumberProd
        xfreeDivArray([1,2]+(k-1)*2,:) = xfreeDivArray([2,1]+(k-1)*2,:);
    end
    xfreeDivIndex = xfreeDivIndex(divideNumberProd:-1:1,:);
end

xfreeDivArrayReturn = xfreeDivArray;
xfreeDivArray(:,ParameterIndex.divParExp) = ...
    exp(xfreeDivArray(:,ParameterIndex.divParExp));

%xfreeDivArray %#ok<NOPRT>
%xfreeDivIndex %#ok<NOPRT>
xDivIsFit = zeros(max(divideNumbers),divParNum,4);

if divideNumberProd > 1
    csvwrite([resultFolder 'xfreeDivArray.csv'], xfreeDivArray)
    csvwrite([resultFolder 'xfreeDivIndex.csv'], xfreeDivIndex)
end

end