function [InitialXY] = selectInitialGroup(f, Model, resultFolder, InitialXY, Numbers, ForODE, ParameterIndex) %#ok<INUSL>

'Select initial group' %#ok<NOPRT>


%% Line 1
X_k_half=InitialXY.xfree_distribution_log;

%% Line 2-2
%prepare X and Y for calculation
Y_k_half=zeros(Numbers.goal,Numbers.samp);
XforCalculation = zeros(Numbers.samp,Numbers.xfree+Numbers.xfix);

%prepare X for calculation
for k1=1:Numbers.samp
      XforCalculation(k1,ParameterIndex.fix) = InitialXY.xfix(1:Numbers.xfix);
      XforCalculation(k1,ParameterIndex.free(ParameterIndex.normalDist)) = X_k_half(ParameterIndex.normalDist,k1);
      XforCalculation(k1,ParameterIndex.free(ParameterIndex.expDist)) = exp(X_k_half(ParameterIndex.expDist,k1));
end

%solve ODE
parfor k1=1:Numbers.samp
  Y_k_halfCalc = [];
  for k2 = 1:Numbers.sepCond %#ok<PFBNS>
    [youtCalc t uCalc]=...
      f(XforCalculation(k1,:), Model, Numbers, ForODE, k1, k2); %#ok<PFBNS,NASGU,ASGLU>
    if k2 == 1
      Y_k_halfCalc = youtCalc;
    else
      Y_k_halfCalc = [Y_k_halfCalc youtCalc];
    end
  end
  Y_k_half(:,k1) = Y_k_halfCalc';
end

if Numbers.goal ==1
   inf_index = find(Y_k_half==Inf);
else
   inf_index=find(sum(Y_k_half)==Inf);
end
notcalc_index2 = inf_index;
l_inf=size(notcalc_index2,2) %#ok<NASGU,NOPRT>

%% Line 2-3

Y_normalized=diag(1./InitialXY.y_star)*Y_k_half;

Y_normalizedDiffSum = sum((Y_normalized-1).^2,1).^(1/2);
[median(Y_normalizedDiffSum) sum(Y_normalizedDiffSum)/Numbers.samp min(Y_normalizedDiffSum) max(Y_normalizedDiffSum)] %#ok<NOPRT>

[ydiffSorted ydiffSortedIndex] = sort(Y_normalizedDiffSum); %#ok<ASGLU>
[ydiffSorted ydiffSortedIndex] = sort(ydiffSortedIndex); %#ok<ASGLU>

rand_val=rand(floor(Numbers.samp/3),Numbers.samp-floor(Numbers.samp/3));
rand_val_normalized = rand_val * diag(1./sum(rand_val));

Xreplace = (X_k_half(:,ydiffSortedIndex<=Numbers.samp/3) * rand_val_normalized);
X_k_half(:,ydiffSortedIndex>Numbers.samp/3) = Xreplace;

InitialXY.xfree_distribution_log = X_k_half;

end