function [resultFolder,calcIDout] = prepareFolder(Setting, suffix, comment)

calcFolder = [cd '/../'];

cDate  = datestr(now, 'yyyymmdd-HHMM');
cMonth = datestr(now, 'yyyymm');
calcID = cDate;

if nargin == 1
    suffix = '';
elseif nargin == 2
    [commentSave,commentHead] = saveComment;
else
    commentSave = comment;
    commentHead = comment;
end

%% Create folder

isFoldExist = 1;
resultFolderPosi = setting_folder;

while isFoldExist
    
    resultFolder = ...
        [resultFolderPosi,suffix,'/',cMonth,'/',Setting.Model,...
        '/',calcID,'-',commentHead,'/'];
    
    [~,~,messid] = mkdir(resultFolder);
    
    %Change folder name if the folder already exist
    if strcmp(messid,'MATLAB:MKDIR:DirectoryExists')==0
        isFoldExist = 0;
    else
        isFoldExist = isFoldExist + 1;
        calcID = [cDate '-' num2str(isFoldExist)];
    end
end

fid = fopen([resultFolder commentHead '-comment.txt'], 'wt');
fprintf(fid,'%s\n', commentSave); fclose(fid);


%% Copy scripts and model files

zip('../../modelFile.zip',[calcFolder '../Model/' Setting.Model]); 
zip('../../scriptsStore.zip',calcFolder); 

copyfile(Setting.setFile,resultFolder); 

if strcmp(computer('arch'),'win32') || strcmp(computer('arch'),'win64')
    movefile('..\..\modelFile.zip',resultFolder); 
    movefile('..\..\scriptsStore.zip',resultFolder);
else
    movefile('../../modelFile.zip',resultFolder); 
    movefile('../../scriptsStore.zip',resultFolder);
end

if nargout == 2
   calcIDout = calcID; 
end

end




function [commentSave,commentHead] = saveComment

commentSave = input('Comment?: ','s');
if isempty(commentSave)
    commentHead = [];
else
    blankIndex = strfind(commentSave, ' ');
    if isempty(blankIndex)
        commentHead = commentSave;
    else
        commentHead = commentSave(1:(blankIndex-1));
    end
end

end
