function simulationMulti(modelSimuFolder,set_resultFolder,set_samp,saveFigNum)
%%

if 0
    set_resultFolder = ['C:\Users\Yoshida/Dropbox/0-inv_prob_yoshi/results/201310/RPG/inhTC_130930_itzOATP/' ...
        'RPG_wiM1_each/20131001-1216-corrActTC/']; %#ok<UNRCH>
    simulationRPG('RPG/inhTC_130930_itzOATP/RPG_woM1_both',set_resultFolder,1000,20)
    
    set_resultFolder = ['C:\Users\Yoshida/Dropbox/0-inv_prob_yoshi/results/201310/RPG/inhTC_130930_itzOATP/' ...
        'RPG_woM1_each/20131001-1203-corrActTC/'];
    simulationRPG('RPG/inhTC_130930_itzOATP/RPG_woM1_both',set_resultFolder,1000,20)
end


%% Check whether set_resultFolder exsist or not

if exist([set_resultFolder,'1'],'dir') ~= 7
   error(['No designated result folder: ',set_resultFolder]) 
end

%%
matlabpool size, if ans==0, matlabpool open, end %#ok<NOANS>

resultFolderSummary = [set_resultFolder,'0-summary/'];
mkdir(resultFolderSummary)

y_outMeanArr      = zeros(1,4);
y_outSTDEVArr     = zeros(1,4);
y_outNormMeanArr  = zeros(1,4);
y_outNormSTDEVArr = zeros(1,4);

kPara = 1;

calc = 1;
resultFolder = [set_resultFolder,num2str(kPara),'/'];
if exist([resultFolder,'finalXY/FinalXsorted.mat'],'file')
    load([resultFolder,'finalXY/FinalXsorted'])
elseif exist([resultFolder,'finalXY/FinalXYsortY.mat'],'file')
    load([resultFolder,'finalXY/FinalXYsortY'])
    FinalXsorted = FinalXsortY;
else
    calc = 0;
end

if calc
    [Y_k_half,iniXY_y_star]...
        = simulationMulti_run(FinalXsorted,modelSimuFolder,resultFolderSummary,saveFigNum,kPara);
    
    [y_outMeanArr(kPara,:),y_outSTDEVArr(kPara,:),...
        y_outNormMeanArr(kPara,:),y_outNormSTDEVArr(kPara,:),...
        y_outNorm]...
        = createYdistFig(kPara,set_samp,Y_k_half,iniXY_y_star); %#ok<NASGU>
    
    save([resultFolderSummary,'Y_k_half_', num2str(kPara)],'Y_k_half')
    save([resultFolderSummary,'y_outNorm_',num2str(kPara)],'y_outNorm')
    csvwrite([resultFolderSummary,'Y_k_half_',num2str(kPara),'.csv'], Y_k_half)
    
end

save([resultFolderSummary,'iniXY_y_star'],'iniXY_y_star')
csvwrite([resultFolderSummary,'iniXY_y_star.csv'], iniXY_y_star)
save([resultFolderSummary,'y_outMeanArr'],'y_outMeanArr')
save([resultFolderSummary,'y_outSTDEVArr'],'y_outSTDEVArr')

set(figure(21),'position', [50 70 800 800]);
hgexport(figure(21),[resultFolderSummary,'normY_fig.png'],hgexport('factorystyle'),'Format','png');
saveas(figure(21),[resultFolderSummary,'normY_fig.fig'])
close(figure(21))


end


function [Y_k_half,iniXY_y_star] = simulationMulti_run(xArray,Model,resultFolder,saveFigNum,kPara)

calcType = 'simulation';

%% Settings
Setting = struct;

Setting.Model=Model;
Setting.odeSolvers= {@ode15s};

Setting.useTemp = 1;

if exist(['../Model/',Model],'dir') ~= 7
   error(['No designated model files: ',Model]) 
end

%% prepare parameters

Numbers = ...
    struct('extrapolateAUCthres', 1/1000,'extrapolateAUCinf', 3,'sepAUCIndex',4);
IniXY  = struct;
ForODE = struct('useTemp', Setting.useTemp);
ParaInd= struct;


copyfile(['../Model/',Setting.Model,'/ActualTimeCourse_par.csv'],...
         ['../Model/',Setting.Model,'/ActualTimeCourse.tmp.csv']);
copyfile(['../Model/',Setting.Model,'/y_outEq1_par.txt'],...
         ['../Model/',Setting.Model,'/y_outEq1.tmp.txt']);
if exist(['../Model/',Setting.Model,'/y_star_par.csv'])
copyfile(['../Model/',Setting.Model,'/y_star_par.csv'],...
         ['../Model/',Setting.Model,'/y_star.tmp.csv']);
end


%prepare imported parameter and Jacobian
cd('import');
[ForODE,Numbers,IniXY,~] = importParameters(Model,Numbers,IniXY,ForODE,ParaInd,calcType);
cd('../');


IniXY.xArray = xArray;

Numbers.samp = size(IniXY.xArray,1);
Numbers.input = size(IniXY.xArray,2);


%% Apply settings

ForODE.odeSolvers    = Setting.odeSolvers;


%% Calculation
%Numbers, ForODE %#ok<NOPRT>

%IniXY %#ok<NOPRT>
%IniXY.xArray'



uCell = cell(1,Numbers.samp);
Y_k_half = zeros(Numbers.samp,Numbers.goal);

xArray = IniXY.xArray;

%Numbers.sepCond


parfor ksamp= 1:Numbers.samp
    cd('calc');
    
    XforCalculation = xArray(ksamp,:)';
    
    uEach = [];
    Y_k_halfEach = [];
    for k2 = 1:Numbers.sepCond %#ok<PFBNS>
        
        [youtCalc,t,uCalc]=PBPK_model(XforCalculation, Model, Numbers, ForODE, 1, k2); %#ok<ASGLU>
        
        sizeuCalc = size(uCalc,1);
        if sizeuCalc<size(Numbers.timePoints,2)
            uCalc = [uCalc; zeros(size(Numbers.timePoints,2) - sizeuCalc,Numbers.compAll(k2))];
        end
        
        uEach = [uEach uCalc];
        Y_k_halfEach = [Y_k_halfEach youtCalc];
        
    end
    
    uCell{ksamp} = uEach;
    Y_k_half(ksamp,:) = Y_k_halfEach;
    cd('../');
end





%% Combine u values for figure
for ksamp = 1:saveFigNum
    u = uCell{ksamp};
    for k1 = 1:Numbers.timeFitCompNum
        uFig(:,ksamp,k1) = u(:,Numbers.timeFitComp(1,k1)); %#ok<AGROW>
    end
end

%uFig

%% output and close
figure(1)
clf(figure(1))

legendLabel = cell(saveFigNum+1,1);
for ksamp = 1:saveFigNum
    legendLabel{ksamp} = ['#',num2str(ksamp)];
end
legendLabel{saveFigNum+1} = 'Observed'; %#ok<NASGU>

lineColorMap = winter(saveFigNum+1);
%lineColorMap = lineColorMap(end:-1:1,:);
set(gcf, 'DefaultAxesColorOrder', lineColorMap)


for k1 = 1:Numbers.timeFitCompNum
    subplot(1,Numbers.timeFitCompNum,k1);
    semilogy(Numbers.timePoints, uFig(:,:,k1),'b-', ...
        'LineWidth', 1.5);%, 'LineColor', [0,0,0]);
    
    hold on
    actTimeCourse = Numbers.actTimeCourse(:,k1);
    
    plot(Numbers.timePoints, actTimeCourse, 'mo', ...
        'MarkerEdgeColor', [1,0,0], 'MarkerFaceColor', [1,0.5,0],...
        'LineWidth', 1.2, 'MarkerSize', 10);
    
    
    axis tight
    %hleg1 = legend(legendLabel);
    
    xlim(Numbers.xlim)
    ylim(Numbers.ylim)
    set(gca,'FontSize',12);
    
    hold off
end


set(figure(1),'position', [150 70 1024 400]);
set(figure(1),'position', [150 70 1024 300]);
hgexport(figure(1),[resultFolder,'simulation_',num2str(kPara),'.png'],hgexport('factorystyle'),'Format','png');
%saveas(figure(1),[resultFolder,'simulation_',num2str(kPara),'.png'])
%saveas(figure(1),[resultFolder,'simulation_',num2str(kPara),'.fig'])


%exportY = [IniXY.y_star', Y_k_half'] %#ok<NOPRT,NASGU>
%exportYdiv = diag(1./IniXY.y_star) * Y_k_half' %#ok<NOPRT>
%csvwrite([resultFolder,'normY_save_',num2str(kPara),'.csv'], exportYdiv)

iniXY_y_star = IniXY.y_star;
end




function [y_outMean,y_outSTDEV,y_outNormMean,y_outNormSTDEV,y_outNorm] = ...
    createYdistFig(kPara,set_samp,Y_k_half,iniXY_y_star)

figure(21)

lineColorMap = [0,65,255;250,245,0;53,161,107;255,40,0]/255;
set(gcf, 'DefaultAxesColorOrder', lineColorMap)    
set(gca,'FontSize',6);

semilogy(Y_k_half(:,1:4), 'LineWidth', 0.5);
hold on
plot([0,set_samp], [iniXY_y_star(1:4)', iniXY_y_star(1:4)'], 'k-','LineWidth', 0.5);
ylim([100,10000]);

%Ysum = sum(exportY,1);
%size(exportY)
%Ysum1 = sum(exportY(1:14,:),1)
%Ysum2 = sum(exportY(15:23,:),1)

Y_k_half = Y_k_half(1:floor(size(Y_k_half,1)/2),1:4);

Y_k_half(sum(Y_k_half==Inf,2)>0,:) = []; 

y_out     = Y_k_half;
y_outNorm = Y_k_half * diag(1./iniXY_y_star(1:4));

y_outMean      =mean(y_out);
y_outSTDEV     = std(y_out);
y_outNormMean  =mean(y_outNorm);
y_outNormSTDEV = std(y_outNorm);


end