function goalVector = PBPK_model_LM(xfree)

global Numbers2 ForODE2 ParameterIndex2 InitialXY2
Numbers = Numbers2;
ForODE = ForODE2;
ParameterIndex = ParameterIndex2;

x_in(ParameterIndex.fix) = InitialXY2.xfix;
x_in(ParameterIndex.free) = xfree;
x_in(ParameterIndex.free(ParameterIndex.expDist)) = ...
  exp(x_in(ParameterIndex.free(ParameterIndex.expDist)));
%x_in(ParameterIndex.free)
loopNumber = 1;

%% Calc ODE

uCalcAll = [];

for conditionNumber = 1:Numbers.sepCond
  switch char(ForODE.calcAlgorithm(1))
    case 'ode'
      for k = 1:numel(ForODE.odeSolvers)
        [t uCalc] = solveODE(ForODE.odeSolvers{k}, x_in, Numbers, ForODE, loopNumber, conditionNumber);
        if t(end)==Numbers.timePoints(end), break; end
      end
    case 'FILT'
      [t uCalc] = solveFILT(x_in, Numbers, ForODE, conditionNumber);
  end
  
  sizeuCalc = size(uCalc,1);
  if sizeuCalc<size(Numbers.timePoints,2)
    uCalc = [uCalc; zeros(size(Numbers.timePoints,2) - sizeuCalc, Numbers.compAll(conditionNumber))]; %#ok<AGROW>
  end
  
  uCalcAll = [uCalcAll uCalc]; %#ok<AGROW>
  u = uCalc;
  
  %% Calc ystars
  nan_indexU = find(isnan(uCalc)); l_nan=size(nan_indexU,1);
  if l_nan~=0, t = -3, 'u reached NaN', end %#ok<NOPRT>
  
  y_out = zeros(1,Numbers.goalEach(conditionNumber));
  if t(end)==Numbers.timePoints(end) %calc y_out if a simulation completed successfully
    u1 = zeros(size(Numbers.timePoints,2), Numbers.goalEach(conditionNumber));
    
    for k = 1:Numbers.goalEach(conditionNumber)
      if numel(u1(:,k)) ~= numel(u(:,ForODE.y_outCompNumEachCond{conditionNumber}(k)))
        u(:,ForODE.y_outCompNumEachCond{conditionNumber}(k))
      end
      u1(:,k) = u(:,ForODE.y_outCompNumEachCond{conditionNumber}(k));
    end
    
    y_out = calcY_stars(Numbers.timePoints',u1,ForODE.y_outEqAll{conditionNumber},Numbers);
    
  else %y_out = Inf if a simulation did not completed
    for k=1:Numbers.goalEach(conditionNumber)
      y_out(k) = Inf;
    end
  end
  nan_indexY = find(isnan(y_out)); l_nan=numel(nan_indexY);
  if l_nan~=0, t = -4, 'y_out reached NaN', end %#ok<NOPRT>
  
  if t(1) < 0, break, end
end

if t(1) < 0
  goalVector = Inf;
else
  
  %% Calc Targed Values
  switch ForODE.fitType
    %% ystar
    case 1
      
      goalVector = (InitialXY2.y_star - y_out)./InitialXY2.y_star;
      
      %% SS
    case 2
      
      if t(end)==Numbers.timePoints(end) %calc y_out if a simulation completed successfully
        u1LogDiff = zeros(1,Numbers.goal);
        
        for k = 1:Numbers.goal
          u1 = [uCalcAll(:,k) ...
            Numbers.actTimeCourse(:,Numbers.actTimeCourse(1,:) == ...
            ForODE.y_outCompNumAll(k))];
          
          u1(1,:) = []; 
          u1((u1(:,2)==0),:) = [];
          
          u1LogDiff(k) = sum(log((u1(:,1)-u1(:,2)).^2));
        end
        
        logSS = u1LogDiff;
        
      else %y_out = Inf if a simulation did not completed
        logSS = Inf;
      end
      
      goalVector = logSS;
      
    otherwise
      error('Wrong setting in fittingType value')
  end
  
end

end