function mainLM1to5

%% Settings

cd('setting');
Setting = struct;
Setting.setFile = 'setting_LM1to5.txt';

Setting = importSetting(Setting);
Setting = setComputerType(Setting);

Setting.calcType = 'mainLMauto';


%% Parameter and folder preparation

[Setting,calcFolder,resultFolderParent,calcID] = ...
    prepareFolder(Setting); %#ok<ASGLU,NASGU>
Setting.resultFolderParent = resultFolderParent;
cd('../');

%% 1 - 2com

[x_out(:,1),AIC(1)] = callMainLMeach(Setting,1,'/1','1-1com/');
[x_out(:,2),AIC(2)] = callMainLMeach(Setting,2,'/1','1-2com/');

% Use Vb, ka, and Lag from the result with lower AIC
Setting.vbkalag = x_out(1:3, AIC == min(AIC))';

%% 4 - PBPK

[x_out4,~] = callMainLMeach(Setting,4,'/4','4/');

% Calculate each CLs from the ratios
dif_act = x_out4(4,:)';  
inf_all = x_out4(5,:)'; 
clall   = x_out4(6,:)';  
kbile   = x_out4(21,:)';

psinf = inf_all.* clall;
pseff = psinf  ./ (1 + 1./dif_act);
clint = pseff  ./ (inf_all - 1);

Setting.CLs = [psinf,pseff,clint,kbile];

%% 5 - PBPK

[x_out5,~] = callMainLMeach(Setting,5,'/5','5/'); %#ok<ASGLU>


%% Close

matlabpool size, if ans ~= 0, matlabpool close; end %#ok<NOANS>
if strcmp(computer('arch'),'glnxa64')
    %quit
end


end




function [x_out,AIC] = callMainLMeach(SettingParent,condNum,modelAdd,foldAdd)

Setting = SettingParent;

if nargin == 1  
    Setting.Model  = [Setting.Model];
    resultFolder   = [SettingParent.resultFolderParent];
elseif nargin == 4
    Setting.Model  = [Setting.Model modelAdd];
    resultFolder   = [SettingParent.resultFolderParent, foldAdd];
    mkdir(resultFolder)
end


cd('import');
parameters=...
    str2double(importStr(['../../Model/', Setting.Model,'/','Parameters_LM.csv'],','))';
cd('../');


if condNum == 1
    parameters(:,5:6) = 0;
elseif condNum == 4
    parameters(1:end-3,1:3) = repmat(Setting.vbkalag,size(parameters(1:end-3,:),1),1);
elseif condNum == 5
    parameters(1:end-3,[4:6,21]) = Setting.CLs;
end

csvwrite(['../Model/', Setting.Model,'/','Parameters_LM.tmp.csv'], parameters')


cd('calc');
[x_out,AIC] = mainLMeach(resultFolder,Setting,parameters);
cd('../');


end
