function mainLM20

%% Settings

cd('setting');
Setting = struct;
Setting.setFile = 'setting_LM20.txt';

Setting = importSetting(Setting);
Setting = setComputerType(Setting);

Setting.calcType = 'mainLMauto';


%% Parameter and folder preparation

[Setting,calcFolder,resultFolderParent,calcID] = ...
    prepareFolder(Setting); %#ok<ASGLU,NASGU>
Setting.resultFolderParent = resultFolderParent;
cd('../');


[x_out,AIC] = callMainLMeach(Setting); %#ok<NASGU,ASGLU>

end




function [x_out,AIC] = callMainLMeach(SettingParent,condNum,modelAdd,foldAdd) %#ok<INUSL>

Setting = SettingParent;

if nargin == 1  
    Setting.Model  = [Setting.Model];
    resultFolder   = [SettingParent.resultFolderParent];
elseif nargin == 4
    Setting.Model  = [Setting.Model modelAdd];
    resultFolder   = [SettingParent.resultFolderParent, foldAdd];
    mkdir(resultFolder)
end


cd('import');
parSubs=...
    str2double(importStr(['../../Model/', Setting.Model,'/','Parameters_LM_subs.csv'],','))';
parInhi=...
    str2double(importStr(['../../Model/', Setting.Model,'/','Parameters_LM_inhi.csv'],','))';
cd('../');

parSet = [parSubs(end-2:end,:),parInhi(end-2:end,:)];
parSubs = parSubs(1:end-3,:);
parInhi = parInhi(1:end-3,:);

sizeS = size(parSubs);
sizeI = size(parInhi);

parameters = zeros(sizeS(1)*sizeI(1), sizeS(2)+sizeI(2));
parameters = [parameters; parSet];

% Substrate
subsInd = 1:sizeI(1):sizeS(1)*sizeI(1);
for k = 0:sizeI(1)-1
    parameters(subsInd+k, 1:sizeS(2)) = parSubs;
end

% Inhibitor
for k = 0:sizeS(1)-1
    parameters(1+k*sizeI(1):(k+1)*sizeI(1),sizeS(2)+1:end) = parInhi;
end

csvwrite(['../Model/', Setting.Model,'/','Parameters_LM.tmp.csv'], parameters');


[x_out,AIC] = mainLMeach(resultFolder,Setting,parameters);

end
