function [t u] = solveODE2expt(fode, x_in, Numbers, ForODE, loopNumber, condNum)
%SOLVEODE Solve ode
%   詳細説明をここに記述

global x Numbers2 ForODE2 CLmatrixValues CompVolumes
global startTime isLongCalcTime longCalcSample odeStopped condNum2
x=(x_in);

startTime = tic; isLongCalcTime = 0; longCalcSample = loopNumber; odeStopped = 0;
condNum2 = condNum;
[Numbers2 ForODE2] = setNumbersForODE(Numbers, ForODE, condNum);

%% Prepare fluxmatrix w/o u()
CLmatrixValues = zeros(Numbers2.comp);

for k=1:Numbers2.FluxmatrixFirstCalcNum
  CLmatrixValues(ForODE2.FluxmatrixFirstCalcIndex(k)) = ...
    eval(char(ForODE2.Fluxmatrix(ForODE2.FluxmatrixFirstCalcIndex(k))));
end

%% Prepare compvolumes
CompVolumes = zeros(1,Numbers2.conc);
for k1=1:Numbers2.conc
  CompVolumes(1,k1)=...
    eval(char(ForODE2.volumes{condNum}(ForODE2.isconc(k1))));
end 

%% Prepare initial values w/o tlag
uinitial=zeros(1,Numbers2.comp);
for k1=1:Numbers2.nottlag
  uinitial(Numbers2.nottlagindex(k1)) = ...
    eval(char(ForODE2.initialamountEq{condNum}(Numbers2.nottlagindex(k1))));
end

%% Select RHS
if Numbers2.complexDose==0
  RHS=@RHS0;
elseif numel(ForODE.infIndex{condNum2})==0
  RHS=@RHS0;
else
  RHS=@RHS1;
  for k=1:numel(ForODE2.infIndex{condNum2})
    ForODE2.infTotalDoseEval(k)=eval(ForODE2.infTotalDose{condNum2}{k});
    ForODE2.infDurEval(k)=eval(ForODE2.infDur{condNum2}{k});
  end
end

%% Main calculation
options=odeset('Events',@events,'JPattern',ForODE2.jacobian_index);
if Numbers2.tlag==0
  [t,u]=fode(RHS, Numbers2.timePoints, uinitial', options);  %SOLVING ODE
else
  [tlag tlagforCalc tlagEraseIndex timePointsForCalc] = separateTimePoints(Numbers2, ForODE2, x, condNum);
  
  tlagforCalc = [0 tlagforCalc];
  tcombine = []; ucombine = [];
  
  for k = 1: size(timePointsForCalc,2)
    k
    
    tp = timePointsForCalc{k}
    twoTimePoints = 0;
    
    % Prepare initial values
    uinitialPlusIndex = Numbers2.tlagindex(tlag==tlagforCalc(k));
    if k>1  
      uinitial = uend;
      for k1 = 1:size(uinitialPlusIndex,2)
        uinitial(uinitialPlusIndex(k1))= ...
          uend(uinitialPlusIndex(k1)) + ...
          eval(char(ForODE2.initialamountEq{condNum}(uinitialPlusIndex(k1))));
      end
    end
    
    % If contain only two time points
    if size(timePointsForCalc{k},2) == 2
      twoTimePoints = 1;  
      tp = [tp(1) (tp(1)+tp(2))/2 tp(2)];
      tp
    end
    
    % Calculation
    if sum(uinitial) ==0
      t=zeros(size(tp,2),1);
      u=zeros(size(tp,2),Numbers2.comp);
    else
      [t,u]=fode(RHS, tp, uinitial', options);  %SOLVING ODE
    end
    if twoTimePoints, t(2) = []; u(2,:) = []; end
    
    t
    
    % Erase end point except for final loop
    if k <size(timePointsForCalc,2)
      uend =  u(end,:);
      t(end) = []; u(end,:) = [];
    end
    t = t + tlagforCalc(k);
    
    t
    
    if tlagEraseIndex(k)
      t(1) = []; u(1,:) = [];
    end
    
    t
    
    tcombine = [tcombine;t]; %#ok<AGROW>
    ucombine = [ucombine;u]; %#ok<AGROW>
    
    tcombine
  end
  
  t=tcombine;
  u=ucombine;
  
end



end


%%
function [hReturn]=RHS0(t,u)
%normal administration
global x ForODE2 CompVolumes

hReturn=h(x,u,t);

%if t>4, hReturn, end

%devide with volumes
hReturn(ForODE2.isconc)=hReturn(ForODE2.isconc)./CompVolumes';

%if t>4, hReturn, a, end

end

%%
function [hReturn]=RHS1(t,u)
%complicated administration
global x ForODE2 CompVolumes condNum2

hReturn=h(x,u,t);

for k=1:numel(ForODE2.infIndex{condNum2})
  if t <= ForODE2.infDurEval(k)
    hReturn(ForODE2.infIndex{condNum2}(k))=...
      hReturn(ForODE2.infIndex{condNum2}(k)) + ...
      ForODE2.infTotalDoseEval(k)./ForODE2.infDurEval(k);
  end
end

%devide with volumes
hReturn(ForODE2.isconc)=hReturn(ForODE2.isconc)./CompVolumes';

end

%%

function h=h(x,u,t) %#ok<INUSD,INUSL>

global Numbers2 ForODE2 CLmatrixValues 
global startTime isLongCalcTime longCalcSample odeStopped %#ok<NUSED>
%global Numbers2 CLmatrix2 Model2  ConcIndex2 CompImport2 

%calculate flux w/ u()
for k=1:Numbers2.FluxmatrixLaterCalcNum
  CLmatrixValues(ForODE2.FluxmatrixLaterCalcIndex(k)) = ...
    eval(char(ForODE2.Fluxmatrix(ForODE2.FluxmatrixLaterCalcIndex(k))));
end

%Calculate efflux to subtract
CLmatrixValues2 = CLmatrixValues;
CLmatrixdiag=sum(CLmatrixValues2 - diag(diag(CLmatrixValues2)));
CLmatrixValues2 = CLmatrixValues2 - diag(CLmatrixdiag);

%compute the right hand side
h=CLmatrixValues2 * u;

%if t>4, t, CLmatrixValues2, u, end

if toc(startTime) > 120
  if odeStopped == 0
    odeStopped=1; 
  end
end

end

%%
function [value,isterminal,direction] = events(t,u) %#ok<INUSD>
global odeStopped

value = 1-odeStopped;
isterminal = 1;
direction = 0;

end

function [Numbers2 ForODE2] = setNumbersForODE(Numbers, ForODE, condNum)

Numbers2 = Numbers;
ForODE2 = ForODE;

ForODE2.FluxmatrixFirstCalcIndex =  ForODE.FluxmatrixFirstCalcIndexAll{condNum};
ForODE2.FluxmatrixLaterCalcIndex =  ForODE.FluxmatrixLaterCalcIndexAll{condNum};
ForODE2.Fluxmatrix =  ForODE.FluxmatrixAll{condNum};
%ForODE2.y_outEq = ForODE.y_outEqAll{condNum};
ForODE2.jacobian_index = ForODE.jacobian_indexAll{condNum};
Numbers2.FluxmatrixFirstCalcNum = Numbers.FluxmatrixFirstCalcNumAll(condNum);
Numbers2.FluxmatrixLaterCalcNum = Numbers.FluxmatrixLaterCalcNumAll(condNum);
ForODE2.isconc = ForODE.isconcAll{condNum};
Numbers2.conc = Numbers.concAll(condNum);
Numbers2.comp = Numbers.compAll(condNum);
Numbers2.nottlagindex = Numbers2.nottlagindexAll{condNum};
Numbers2.tlagindex = Numbers2.tlagindexAll{condNum};
Numbers2.nottlag = Numbers2.nottlagAll(condNum);
Numbers2.tlag = Numbers2.tlagAll(condNum);

end
